####
# Converted to Tkogl v3.0
# March/2001, by group 5, EECE 285
# The University of British Colubia
####

package require Tkogl
package require OpenGL
package require OpenGLU

###########Generic Functions:

set Xeye 0 
set Yeye 0 
set Zeye 0 
set Xcenter 0
set Ycenter 0
set Zcenter -10
set storeZoomAngle 35
set storeOrthoZoom 2
set storeVarXpan  0
set storeVarYpan  0
set worldFlag 0
set projFlag 0
set tempXrot 0
set tempYrot 0
set tempZrot 0
set Bt 0.3
set B0x 0
set B0y 0
set B0z 0.3
set B1x 0.3
set B1y 0
set B1z 0
set xarrowB0 0
set yarrowB0 0
set zarrowB0 0
set xarrowB1 0
set yarrowB1 0
set zarrowB1 0
set degree 0
set Ux 0
set Uy 1
set Uz 1
set newRadius [expr sqrt(2)]


################# for generic function uses  file generic2
source Util-generic2.tcl

 
########### the main widget 
catch { destroy .gl }
pack [OGLwin .gl -refresh draw -width 300 -height 300 -doublebuffer 1] -side top

catch { destroy .gl2 }
pack [OGLwin .gl2 -refresh draw2 -width 300 -height 300 -doublebuffer 1] -side left

catch { destroy .gl3 }
pack [OGLwin .gl3 -refresh draw3 -width 300 -height 300 -doublebuffer 1] -side right


update idletasks

# display lists for cones and circles and arrows

set cone [.gl cylinder 0 1.25 0.7 40 40]
set circle [.gl cylinder 1.25 1.25 0.02 40 40]
set arrow [.gl cylinder 0 0.1 0.2 8 8]

#GL2
set cone2 [.gl2 cylinder 0 $newRadius 0.01 40 40]
set circle2 [.gl2 cylinder $newRadius $newRadius 0.02 40 40]
set arrow2 [.gl2 cylinder 0 0.05 0.1 8 8]

#GL3 
set cone3 [.gl3 cylinder 0 1 1 40 40]
set circle3 [.gl3 cylinder 1 1 0.02 40 40]
set arrow3 [.gl3 cylinder 0 0.05 0.1 8 8]

set objarrowB1 [.gl3 cylinder 0 0.08 0.13 8 8]
set objarrowB0 [.gl2 cylinder 0 0.08 0.13 8 8]


#list of objects 
set objectMomentVec [glGenLists 1]
set objectcone [glGenLists 1]
set objectcircle [glGenLists 1]
set vectorobj [glGenLists 1]
set objectarrow [glGenLists 1]
set productobj [glGenLists 1]
set WorldCoord [glGenLists 1]

#gl2
set objectcone2 [glGenLists 1]
set objectcircle2 [glGenLists 1]
set vectorobj2 [glGenLists 1]
set objectarrow2 [glGenLists 1]
set B1Fieldarrow [glGenLists 1]
set productobj2 [glGenLists 1]
set WorldCoord2 [glGenLists 1]

#GL3
set objectcone3 [glGenLists 1]
set objectcircle3 [glGenLists 1]
set vectorobj3 [glGenLists 1]
set objectarrow3 [glGenLists 1]
set B0Fieldarrow [glGenLists 1]
set productobj3 [glGenLists 1]
set WorldCoord3 [glGenLists 1]

set Shift -10


set phaseB01 90 
set phaseB02 [expr 90 - 18]
set phaseB11 45 
set phaseB12 [expr 45 - 18 ]


proc DrawCone { val } {
       global objectcone cone objectcone2 objectcone3 
       global cone2 cone3 Shift 
       
	.gl makeCurrent

	catch {glDeleteLists $objectcone 1}
	glNewList $objectcone GL_COMPILE 
	glColor4f 0.5 0.0 0.5 $val
                glPushMatrix                   
		  glTranslatef 0 0 $Shift
		  glRotatef 45 0 1 0 
		  glCallList $cone
	        glPopMatrix
		glEndList
       .gl redraw

	.gl2 makeCurrent

	catch {glDeleteLists $objectcone2 1}
	glNewList $objectcone2 GL_COMPILE
	glColor4f 1.0 1.0 0.0 $val
                glPushMatrix
                    glTranslatef 0 0 $Shift 
		    glRotatef 90 0 1 0 
                    glCallList $cone2 
		glPopMatrix
	glEndList
       .gl2 redraw

#GL3

	.gl3 makeCurrent
	
	catch {glDeleteLists $objectcone3 1}
  	 glNewList $objectcone3 GL_COMPILE
	glColor4f 0.0 1.0 1.0 $val
                glPushMatrix
                glTranslatef 0 0 $Shift 
                glCallList $cone3 
	        glPopMatrix
	glEndList
       .gl3 redraw



}

proc DrawCircle { val } {
       global objectcircle objectcircle2 Shift 
       global circle circle2 objectcircle3 circle3

#GL       
	.gl makeCurrent

	catch {glDeleteLists $objectcircle 1}
	glNewList $objectcircle GL_COMPILE
	glColor4f 0.0 0.0 0.0 $val
			glPushMatrix
			glTranslatef 0 0 [expr $Shift] 
			glColor4f 0.0 0.0 0.0 $val
			glRotatef 45 0 1 0 
			glTranslatef 0.0 0.0 0.7 
			glCallList $circle 
			glPopMatrix
	glEndList
       .gl redraw

#GL2
	.gl2 makeCurrent

	catch {glDeleteLists $objectcircle2 1}
	glNewList $objectcircle2 GL_COMPILE
	glColor3f 1.0 1.0 0.0
                glPushMatrix
                glTranslatef 0 0 $Shift 
		    glRotatef 90 0 1 0 
		    glCallList $circle2 
		    glPopMatrix
	glEndList
       .gl2 redraw

#GL3

	.gl3 makeCurrent

	catch {glDeleteLists $objectcircle3 1}
	glNewList $objectcircle3 GL_COMPILE
	glColor4f 0.0 0.0 0.0 $val
                glPushMatrix
                glTranslatef 0 0 [expr $Shift + 1] 
		    glColor4f 0.0 0.0 0.0 $val 
		    glCallList $circle3 
		    glPopMatrix
	glEndList
       .gl3 redraw

}

proc DrawArrow { degree } {
      global objectarrow objectarrow2 objectarrow3 Shift 
      global arrow2 arrow3 arrow xarrowB1 yarrowB1 zarrowB1 
      global xarrowB0 yarrowB0 zarrowB0 localdeg B1Fieldarrow
      global B0Fieldarrow objarrowB1 objarrowB0 

    set deg [expr 360 - $degree]
#GL
	.gl makeCurrent
	
	catch {glDeleteLists $objectarrow 1}
	glNewList $objectarrow GL_COMPILE
	glColor3f 0.6 0.0 0.7
            glPushMatrix
		glTranslatef 0 0 $Shift 
		glRotatef 45 0 1 0 
		glTranslatef 0 0 1.0 
		glRotatef 180 1 0 0 
		glCallList $arrow 
		glPopMatrix
	glEndList
       .gl redraw
#GL2

	.gl2 makeCurrent

	catch {glDeleteLists $objectarrow2 1}
	glNewList $objectarrow2 GL_COMPILE
	glColor3f 1.0 0.5 0.0
             glPushMatrix
		 glTranslatef $xarrowB1 $yarrowB1 [expr $zarrowB1 + $Shift ] 
		 glRotatef $deg 1 0 0 
		 glRotatef 45 1 0 0 
		 glCallList $arrow2 
		 glPopMatrix
	glEndList

	catch {glDeleteLists $B1Fieldarrow 1}
	glNewList $B1Fieldarrow GL_COMPILE
	glColor3f 0.0 0.0 0.0
                glPushMatrix
		    glTranslatef 0 0 $Shift 
		    glRotatef -90 0 1 0 
		    glTranslatef 0 0 -0.65 
		    glCallList $objarrowB0 
		    glPopMatrix
	glEndList
       .gl2 redraw

#GL3

	.gl3 makeCurrent

	catch {glDeleteLists $objectarrow3 1}
	glNewList $objectarrow3 GL_COMPILE
	glColor3f 1.0 0.0 1.0
           glPushMatrix
		 glTranslatef $xarrowB0 $yarrowB0 [expr $zarrowB0 + $Shift ] 
		 glRotatef $deg 0 0 1 
		 glRotatef -90 0.0 0.0 1 
		 glRotatef 90 1 0.0 0.0 
		 glCallList $arrow3 
	     glPopMatrix
	glEndList

	catch {glDeleteLists $B0Fieldarrow 1}
	glNewList $B0Fieldarrow GL_COMPILE
	glColor3f 0.0 0.0 0.0
                glPushMatrix
		    glTranslatef 0 0 $Shift 
		    glRotatef -180 0 1 0 
		    glTranslatef 0 0 -0.65 
		    glCallList $objarrowB1 
		    glPopMatrix
	glEndList
       .gl3 redraw
}

proc MomentVec { degree } {
       global objectMomentVec Shift  
    
set deg [expr 360 - $degree]

	.gl makeCurrent

	catch {glDeleteLists $objectMomentVec 1}
	glNewList $objectMomentVec GL_COMPILE
	glColor3f 0.0 0.0 0.0
                glPushMatrix
		    glTranslatef 0 0 $Shift 
		    glRotatef $deg 1 0 1 
			glBegin GL_LINES
			glVertex3d 0.0 0.0 0.0 
			glVertex3d 0.0 1.0 1.0 
			glEnd 
			glPopMatrix
	glEndList
       .gl redraw
}

DrawCone 0.3
DrawCircle 0.2
MomentVec 0

#seting up the rotational vector   
proc vectordraw { angle } {
         global vectorobj vectorobj2 ang phaseB01 phaseB02 
   global phaseB11 phaseB12 xcCone1 ycCone1 zcCone1 Shift
   global Bt B0x B0y B0z B1x B1y B1z Ux Uy Uz
	   global productobj currentAng xarrowB0 yarrowB0 zarrowB0 
	   global degree  productobj2 xarrowB1 yarrowB1 zarrowB1 
	   global vectorobj3 productobj3
 
set ang $angle
set v_radius 1
set h 1
for {set i 1} {$i<3} {incr i} {
set phaseB0 phaseB0$i 
set coordB0x$i [expr {$v_radius * [expr cos(($$phaseB0 + $ang)*3.141592654/180)]}]
set coordB0y$i [expr {$v_radius * [expr sin(($$phaseB0 + $ang)*3.141592654/180)]}]
set coordB0z$i $h 
}

#puts "x0: $coordB0x1 y0: $coordB0y1 z0 : $coordB0z1" 

# this radius of circle that moment vector makes due to B1 field (it is on zy plane)
set newRadius [expr sqrt(($coordB0x1*$coordB0x1)+($coordB0y1*$coordB0y1)+($coordB0z1*$coordB0z1))]


for {set i 1} {$i<3} {incr i} {
set phaseB1 phaseB1$i 
set coordB1x$i 0
set coordB1y$i [expr {$newRadius * [expr cos(($$phaseB1 + $ang)*3.141592654/180)]}]
set coordB1z$i [expr {$newRadius * [expr sin(($$phaseB1 + $ang)*3.141592654/180)]}]
}

#puts "x1: $coordB1x1 Y1: $coordB1y1 Z1: $coordB1z1 "

# adding the two component of moment that are affected by B1 and B0 fields (the total Moment) 
set coordRx [expr $coordB0x1 + $coordB1x1 ]
set coordRy [expr $coordB0y1 + $coordB1y1 ]
set coordRz [expr $coordB0z1 + $coordB1z1 ]

# the direction of total moment
set resultMag [expr sqrt(($coordRx * $coordRx)+($coordRy * $coordRy)+($coordRz * $coordRz))] 

#setting the total moment to a fixed size
set unitRx [expr $newRadius * $coordRx / $resultMag]
set unitRy [expr $newRadius * $coordRy / $resultMag]
set unitRz [expr $newRadius * $coordRz / $resultMag]
#puts "unitrx $unitRx unitY $unitRy unitz $unitRz"

#result of B0 feild on the Moment (cross product of them)
set XprodB0 [expr ($coordB0y1 * $B0z) - ($coordB0z1 * $B0y) ]
set YprodB0 [expr ($coordB0z1 * $B0x) - ($coordB0x1 * $B0z) ]
set ZprodB0 [expr ($coordB0x1 * $B0y) - ($coordB0y1 * $B0x) ]

#result of B1 feild on the moment (cross product of them)
set XprodB1 [expr ($coordB1y1 * $B1z) - ($coordB1z1 * $B1y)]
set YprodB1 [expr ($coordB1z1 * $B1x) - ($coordB1x1 * $B1z)]
set ZprodB1 [expr ($coordB1x1 * $B1y) - ($coordB1y1 * $B1x)]

set Xprod2 [expr ($unitRy * ($B1z + $B0z)) - ($unitRz * ($B1y + $B0y))]
set Yprod2 [expr ($unitRz * ($B1x + $B0x)) - ($unitRx * ($B1z + $B0z))]
set Zprod2 [expr ($unitRx * ($B1y + $B0y)) - ($unitRy * ($B1x + $B0x))]


set Xprod [expr $XprodB0 + $XprodB1 ]
set Yprod [expr $YprodB0 + $YprodB1 ]
set Zprod [expr $ZprodB0 + $ZprodB1 ]


#puts "vector is $coordB0x1 $coordB0y1 $coordB0z1 "
#puts "cros product is $XprodB0 $YprodB0 $ZprodB0"

set xarrowB0 [expr $XprodB0 + $coordB0x1] 
set yarrowB0 [expr $YprodB0 + $coordB0y1] 
set zarrowB0 [expr $ZprodB0 + $coordB0z1] 

set xarrowB1 [expr $XprodB1 + $coordB1x1] 
set yarrowB1 [expr $YprodB1 + $coordB1y1] 
set zarrowB1 [expr $ZprodB1 + $coordB1z1] 

DrawArrow $degree
MomentVec $degree

     #.gl makeCurrent

	catch {glDeleteLists $vectorobj 1}
	glNewList $vectorobj GL_COMPILE
            glPushMatrix
		glTranslatef 0 0 $Shift 
		glColor3f 0.6 0.0 0.7
		glBegin GL_LINES
			glVertex3d 0.0 0.0 0.0 
			glVertex3d 0.65 0.0 0.65 
		glEnd 
		glTranslatef 0.0 0.0 [expr -$Shift] 
		glPopMatrix
	glEndList
 
	#.gl makeCurrent

	catch {glDeleteLists $productobj 1}
	glNewList $productobj GL_COMPILE
	glColor3f 1.0 0.0 1.0
            glPushMatrix
		glColor3f 1.0 0.0 0.0
		glTranslatef 0.0 0.0 $Shift 
		glBegin GL_LINES
			glVertex3d $unitRx $unitRy $unitRz 
			glVertex3d [expr $Xprod2 + $unitRx] [expr $Yprod2 + $unitRy] [expr $unitRz + $Zprod2] 
		glEnd
		glPopMatrix
	glEndList

       .gl redraw
#GL2
	#.gl2 makeCurrent

	catch {glDeleteLists $vectorobj2 1}
	glNewList $vectorobj2 GL_COMPILE
	glColor4f 0.0 0.0 0.0 1.0
           glPushMatrix
	     glTranslatef 0.0 0.0 $Shift 
           	glBegin GL_LINES
                  glVertex3d 0.0 0.0 0.0 
                  glVertex3d $coordB1x1 $coordB1y1 $coordB1z1 
            	glEnd 
		glTranslatef 0.0 0.0 [expr -$Shift] 
		glTranslatef 0.0 0.0 $Shift 
		glEnable GL_LINE_STIPPLE
		glLineStipple 1 0x8888 
                glBegin GL_LINES
                  glVertex3d 0.0 0.0 0.0 
                  glVertex3d $coordB1x2 $coordB1y2 $coordB1z2 
                glEnd 
		glDisable GL_LINE_STIPPLE
		glTranslatef 0 0 [expr -$Shift] 
		glTranslatef 0 0 $Shift 
		glDepthMask 1 
		glBegin GL_LINES
                  glVertex3d 0.0 0.0 0.0 
                  glVertex3d 0.65 0.0 0.0 
            	glEnd 
		glDepthMask 0 
	  glPopMatrix
	glEndList

	#.gl2 makeCurrent

	catch {glDeleteLists $productobj2 1}
	glNewList $productobj2 GL_COMPILE
	glColor3f 1.0 0.5 0.0
            glPushMatrix
		glTranslatef 0 0 $Shift 
                glBegin GL_LINES
                  glVertex3d $coordB1x1 $coordB1y1 $coordB1z1 
                  glVertex3d [expr $XprodB1 + $coordB1x1] [expr $YprodB1 + $coordB1y1] 
			[expr $ZprodB1 + $coordB1z1] 
                glEnd 
		glPopMatrix
	glEndList

.gl2 redraw

#GL3
	#.gl3 makeCurrent
	
	catch {glDeleteLists $vectorobj3 1}
	glNewList $vectorobj3 GL_COMPILE
	glColor4f 0.0 0.0 0 1.0 
           glPushMatrix
	     glTranslatef 0 0 $Shift 
           glBegin GL_LINES
                  glVertex3d 0.0 0.0 0.0 
                  glVertex3d $coordB0x1 $coordB0y1 $coordB0z1 
            glEnd 
		glTranslatef 0 0 [expr -$Shift] 
		glTranslatef 0 0 $Shift 
		glEnable GL_LINE_STIPPLE 
		glLineStipple 1 0x8888 
                glBegin GL_LINES
                  glVertex3d 0.0 0.0 0.0 
                  glVertex3d $coordB0x2 $coordB0y2 $coordB0z2 
                glEnd 
		glDisable GL_LINE_STIPPLE 
		glTranslatef 0.0 0.0 [expr -$Shift] 
		glTranslatef 0.0 0.0 $Shift 
		glDepthMask 1 
           	glBegin GL_LINES
                  glVertex3d 0.0 0.0 0.0 
                  glVertex3d 0.0 0.0 0.65 
                glEnd 
		glDepthMask 0 
		glPopMatrix
	glEndList

	#.gl3 makeCurrent

	catch {glDeleteLists $productobj3 1}
	glNewList $productobj3 GL_COMPILE
	glColor3f 1.0 0.0 1.0
            glPushMatrix
		glTranslatef 0.0 0.0 $Shift 
                glBegin GL_LINES
                  glVertex3d $coordB0x1 $coordB0y1 $coordB0z1 
         	glVertex3d [expr $XprodB0 + $coordB0x1] [expr $YprodB0 + $coordB0y1] 
			[expr $ZprodB0 + $coordB0z1] 
                glEnd 
		glPopMatrix
	glEndList

.gl3 redraw

}

#create a switch for rotating the vector
frame .l -bg blue3 -width 200 -height 300
frame .l.rotate 
button .l.rotate.do -command {startRotate 18} -text "rotate now"
#label .l.rotate.angle -text "rot. angle (deg): "
#entry .l.rotate.amount -width 4
frame .l.rotstatus
label .l.rotstatus.currl -text "current vector angle: " 
label .l.rotstatus.current -textvariable currentAng
pack .l.rotate.do -side left
pack .l.rotstatus.currl .l.rotstatus.current -side left -padx 3 -pady 3
pack .l.rotate 
pack .l.rotstatus -padx 3 -pady 3



set startAngle 0
set finishAngle 0
set currentAng 0
proc startRotate {deg} {
    global ang startAngle finishAngle currentAng

# if you want to start the rotation from 0 degrees use this line
#  set currentAng 0
# otherwise the rotation starts where it left off 
   set currentAng $startAngle

# set the angle you want the animation to end at
    set finishAngle [expr $currentAng + $deg]

# call rotate switch (the argument should be used as a rotation increment)
    rotateVector 0
}
    


# this will rotate the vector by amount degrees and 
# continue to do so until finishAngle degrees have been
# exceeded
# NOTE: you'll have to play with this so that things work correctly
#   if you want currentAng to reset to 0 after 360 degrees
#   (one way to do it is to specify the total number of degrees of rotation 
#   rather than a start and finish rotation setting)
proc rotateVector {amount} {
global startAngle finishAngle vectorobj currentAng

        vectordraw -$currentAng

set degree $currentAng
DrawArrow $degree
MomentVec $degree
    if {$currentAng < $finishAngle} {
         incr currentAng $amount
         after 40 "rotateVector 18"
    } else {
       
	if {$currentAng >= 360} {
	set currentAng  0 
	} else {set currentAng $currentAng}
    }
set startAngle $currentAng
}

frame .l.f 
label .l.f.l -text "Transparency"
scale .l.f.cone1 -from 0 -to 1 -resolution 0.01 -label "first cone" -command  DrawCone -orient horizontal
# creating a scale to change the position of the vector on the cone
scale .l.f.vectorAng -from 0 -to 360 -resolution 2 -label "vector angle" -command vectordraw -orient horizontal

pack .l.f -side bottom -padx 3 -pady 3 
pack .l.f.l -side top -padx 3 -pady 3 
pack .l.f.cone1 -side left -padx 3 -pady 3 
#pack .l.f.vectorAng -side bottom -padx 3 -pady 3 

.l.f.cone1 set 0.3

.l.f.vectorAng set 0

pack .l -side top

proc draw { } {

	global Shift vectorobj objectMomentVec objectcircle objectarrow 
	global objectcone WorldCoord val degree angle
 
	.gl makeCurrent

	glEnable GL_BLEND 
      glEnable GL_DEPTH_TEST 
	glEnable GL_LINE_SMOOTH
      glClear GL_COLOR_BUFFER_BIT
      glClear GL_DEPTH_BUFFER_BIT 
	glLineWidth 3
	glPushMatrix
	glTranslatef 0 0 $Shift 
	glBegin GL_LINES
        glColor4f 1.0 0.0 0.0 1.0
          glVertex3d 0.0 0.0 0.0 
          glVertex3d 1.0 0.0 0.0 
        glColor4f 0.0 1.0 0.0 1.0
          glVertex3d 0.0 0.0 0.0 
          glVertex3d 0.0 1.0 0.0 
          glColor4f 0.0 0.0 1.0 1.0
          glVertex3d 0.0 0.0 0.0 
          glVertex3d 0.0 0.0 1.0 
	glEnd 
	glPopMatrix 
	glClearColor 1.0 1.0 1.0 0.1 
	glCallList $vectorobj 
	glCallList $objectMomentVec 
	glCallList $objectcircle 
	glCallList $objectarrow 
	glCallList $objectcone 
	glCallList $WorldCoord

	.gl swapBuffer

}

#GL2
proc draw2 {} {

	global vectorobj2 productobj2 objectcircle2 objectarrow2 B1Fieldarrow 
	global objectcone2 WorldCoord2 Shift

	.gl2 makeCurrent

	glEnable GL_BLEND
      glEnable GL_DEPTH_TEST 
	glEnable GL_LINE_SMOOTH 
      glClear GL_COLOR_BUFFER_BIT
      glClear GL_DEPTH_BUFFER_BIT 
	glLineWidth 3 
	glPushMatrix
	glTranslatef 0 0 $Shift 
	glBegin GL_LINES
        glColor4f 1.0 0.0 0.0 1.0
          glVertex3d 0.0 0.0 0.0 
          glVertex3d 1.0 0.0 0.0 
        glColor4f 0.0 1.0 0.0 1.0
          glVertex3d 0.0 0.0 0.0 
          glVertex3d 0.0 1.0 0.0 
        glColor4f 0.0 0.0 1.0 1.0
          glVertex3d 0.0 0.0 0.0 
          glVertex3d 0.0 0.0 1.0 
	glEnd 
	glPopMatrix 
	glClearColor 1.0 1.0 1.0 0.1 
	glCallList $vectorobj2 
	glCallList $productobj2 
	glCallList $objectcircle2 
	glCallList $objectarrow2 
	glCallList $B1Fieldarrow 
	glCallList $objectcone2 
	glCallList $WorldCoord2

	.gl2 swapBuffer
}

#GL3
proc draw3 {} {
	global vectorobj3 productobj3 objectcircle3 objectarrow3 
	global B0Fieldarrow objectcone3 WorldCoord3 Shift

	.gl3 makeCurrent

	glEnable GL_BLEND 
      glEnable GL_DEPTH_TEST 
	glEnable GL_LINE_SMOOTH 
      glClear GL_COLOR_BUFFER_BIT
      glClear GL_DEPTH_BUFFER_BIT 
	glLineWidth 3 
	glPushMatrix
	glTranslatef 0 0 $Shift 
	glBegin GL_LINES
        glColor4f 1.0 0.0 0.0 1.0
          glVertex3d 0.0 0.0 0.0 
          glVertex3d 1.0 0.0 0.0 
        glColor4f 0.0 1.0 0.0 1.0
          glVertex3d 0.0 0.0 0.0 
          glVertex3d 0.0 1.0 0.0 
        glColor4f 0.0 0.0 1.0 1.0
          glVertex3d 0.0 0.0 0.0 
          glVertex3d 0.0 0.0 1.0 
	glEnd 
	glPopMatrix 
	glClearColor 1.0 1.0 1.0 0.1 
	glCallList $vectorobj3 
	glCallList $productobj3 
	glCallList $objectcircle3 
	glCallList $objectarrow3 
	glCallList $B0Fieldarrow 
	glCallList $objectcone3 
	glCallList $WorldCoord3

	.gl3 swapBuffer

}

#rotational bindings and functions
# default manipulations
bind .gl <Button-1> { set x %x ; set y %y }
bind .gl <B1-Motion> {
    incr xrot [expr %x - $x]
    incr yrot [expr %y - $y]
    set x %x
    set y %y

	Update $zrot
	Update $yrot
	Update $xrot 
	
}
#GL2
bind .gl2 <Button-1> { set x %x ; set y %y }
bind .gl2 <B1-Motion> {
    incr xrot [expr %x - $x]
    incr yrot [expr %y - $y]
    set x %x
    set y %y

	Update $zrot
	Update $yrot
	Update $xrot 
	
}
#GL3
bind .gl3 <Button-1> { set x %x ; set y %y }
bind .gl3 <B1-Motion> {
    incr xrot [expr %x - $x]
    incr yrot [expr %y - $y]
    set x %x
    set y %y

	Update $zrot
	Update $yrot
	Update $xrot 
	
}
set zrot 0
bind .gl <Button-3> { set z %x }
bind .gl <B3-Motion> {

    incr zrot [expr %x - $z]
    set z %x

Update $zrot
Update $yrot
Update $xrot
}
#GL2
bind .gl2 <Button-3> { set z %x }
bind .gl2 <B3-Motion> {

    incr zrot [expr %x - $z]
    set z %x

Update $zrot
Update $yrot
Update $xrot
}

#GL3
bind .gl3 <Button-3> { set z %x }
bind .gl3 <B3-Motion> {

    incr zrot [expr %x - $z]
    set z %x

Update $zrot
Update $yrot
Update $xrot
}

scale .l.x -from -180 -to 180 -command "rotate x" -variable yrot -label X
scale .l.y -from -180 -to 180 -command "rotate y" -variable xrot -label Y
scale .l.z -from -180 -to 180 -command "rotate z" -variable zrot -label Z

proc rotate {ax val} {
   
    global zrot yrot xrot 

Update $zrot
Update $yrot
Update $xrot
}

pack .l.x .l.y .l.z -side left -padx 3 -pady 3


proc Update {var} {

global xrot yrot zrot Shift zoomAngle Xeye Yeye Zeye
global Xcenter Ycenter Zcenter orthoZoom worldFlag WorldCoord
global WorldCoord2 WorldCoord3 projFlag tempZrot tempYrot tempXrot 

if {$projFlag == 0} {

.gl makeCurrent 
	glEnable GL_BLEND 
      glEnable GL_DEPTH_TEST 
      glBlendFunc GL_SRC_ALPHA GL_ONE_MINUS_SRC_ALPHA 
      glMatrixMode GL_PROJECTION
	glLoadIdentity 
	glOrtho [expr -$orthoZoom] $orthoZoom  [expr -$orthoZoom] $orthoZoom  -20 20 
	glMatrixMode GL_MODELVIEW
	glLoadIdentity 
	gluLookAt $Xeye $Yeye $Zeye $Xcenter $Ycenter $Zcenter 0 1 0 
	glTranslatef 0 0 $Shift
	glRotatef $zrot 0 0 1 
	glRotatef $yrot 1 0 0 
	glRotatef $xrot 0 1 0 
	glTranslatef 0 0 [expr -$Shift]

.gl2 makeCurrent 
	glEnable GL_BLEND 
      glEnable GL_DEPTH_TEST 
      glBlendFunc GL_SRC_ALPHA GL_ONE_MINUS_SRC_ALPHA 
      glMatrixMode GL_PROJECTION 
	glLoadIdentity 
	glOrtho [expr -$orthoZoom] $orthoZoom  [expr -$orthoZoom] $orthoZoom  -20 20 
	glMatrixMode GL_MODELVIEW 
	glLoadIdentity 
	gluLookAt $Xeye $Yeye $Zeye $Xcenter $Ycenter $Zcenter 0 1 0 
	glTranslatef 0 0 $Shift 
	glRotatef $zrot 0 0 1 
	glRotatef $yrot 1 0 0 
	glRotatef $xrot 0 1 0 
	glTranslatef 0 0 [expr -$Shift]

.gl3 makeCurrent 
	glEnable GL_BLEND 
      glEnable GL_DEPTH_TEST 
      glBlendFunc GL_SRC_ALPHA GL_ONE_MINUS_SRC_ALPHA 
      glMatrixMode GL_PROJECTION 
	glLoadIdentity 
	glOrtho [expr -$orthoZoom] $orthoZoom  [expr -$orthoZoom] $orthoZoom  -20 20 
	glMatrixMode GL_MODELVIEW 
	glLoadIdentity 
	gluLookAt $Xeye $Yeye $Zeye $Xcenter $Ycenter $Zcenter 0 1 0 
	glTranslatef 0 0 $Shift 
	glRotatef $zrot 0 0 1 
	glRotatef $yrot 1 0 0 
	glRotatef $xrot 0 1 0 
	glTranslatef 0 0 [expr -$Shift]

} else {
.gl makeCurrent 
	glEnable GL_BLEND 
      glEnable GL_DEPTH_TEST 
      glBlendFunc GL_SRC_ALPHA GL_ONE_MINUS_SRC_ALPHA 
	glMatrixMode GL_PROJECTION 
	glLoadIdentity 
	gluPerspective $zoomAngle 1 0.1 50 
	glMatrixMode GL_MODELVIEW 
	glLoadIdentity 
	gluLookAt $Xeye $Yeye $Zeye $Xcenter $Ycenter $Zcenter 0 1 0 
	glTranslatef 0 0 $Shift 
	glRotatef $zrot 0 0 1 
	glRotatef $yrot 1 0 0 
	glRotatef $xrot 0 1 0 
	glTranslatef 0 0 [expr -$Shift]

.gl2 makeCurrent 
	glEnable GL_BLEND 
      glEnable GL_DEPTH_TEST 
      glBlendFunc GL_SRC_ALPHA GL_ONE_MINUS_SRC_ALPHA 
	glMatrixMode GL_PROJECTION 
	glLoadIdentity 
	gluPerspective $zoomAngle 1 0.1 50 
	glMatrixMode GL_MODELVIEW 
	glLoadIdentity 
	gluLookAt $Xeye $Yeye $Zeye $Xcenter $Ycenter $Zcenter 0 1 0 
	glTranslatef 0 0 $Shift 
	glRotatef $zrot 0 0 1 
	glRotatef $yrot 1 0 0 
	glRotatef $xrot 0 1 0 
	glTranslatef 0 0 [expr -$Shift]

.gl3 makeCurrent 
	glEnable GL_BLEND 
      glEnable GL_DEPTH_TEST 
      glBlendFunc GL_SRC_ALPHA GL_ONE_MINUS_SRC_ALPHA 
	glMatrixMode GL_PROJECTION 
	glLoadIdentity 
	gluPerspective $zoomAngle 1 0.1 50 
	glMatrixMode GL_MODELVIEW 
	glLoadIdentity 
	gluLookAt $Xeye $Yeye $Zeye $Xcenter $Ycenter $Zcenter 0 1 0 
	glTranslatef 0 0 $Shift 
	glRotatef $zrot 0 0 1 
	glRotatef $yrot 1 0 0 
	glRotatef $xrot 0 1 0 
	glTranslatef 0 0 [expr -$Shift]


}


 if {$worldFlag == 1 } {

	.gl makeCurrent

	catch {glDeleteLists $WorldCoord 1}
	glNewList $WorldCoord GL_COMPILE
	glColor4f 0.0 0.0 0.0 1.0
	glPushMatrix
	glTranslatef -1 -2 -12 
	glBegin GL_LINES
        glColor4f 1.0 0.0 0.0 1.0
          glVertex3d 0.0 0.0 0.0 
          glVertex3d 1.0 0.0 0.0 
        glColor4f 0.0 1.0 0.0 1.0
          glVertex3d 0.0 0.0 0.0 
          glVertex3d 0.0 1.0 0.0 
        glColor4f 0.0 0.0 1.0 1.0
          glVertex3d 0.0 0.0 0.0 
          glVertex3d 0.0 0.0 1.0 
	  glEnd 
	glPopMatrix
	glEndList

	.gl2 makeCurrent

	catch {glDeleteLists $WorldCoord2 1}
	glNewList $WorldCoord2 GL_COMPILE
	glColor4f 0.0 0.0 0.0 1.0
	glPushMatrix
	glTranslatef -1 -2 -12 
	glBegin GL_LINES
        glColor4f 1.0 0.0 0.0 1.0
          glVertex3d 0.0 0.0 0.0 
          glVertex3d 1.0 0.0 0.0 
        glColor4f 0.0 1.0 0.0 1.0
          glVertex3d 0.0 0.0 0.0 
          glVertex3d 0.0 1.0 0.0 
        glColor4f 0.0 0.0 1.0 1.0
          glVertex3d 0.0 0.0 0.0 
          glVertex3d 0.0 0.0 1.0 
	  glEnd 
	glPopMatrix
	glEndList

	.gl3 makeCurrent

	catch {glDeleteLists $WorldCoord3 1}
	glNewList $WorldCoord3 GL_COMPILE
	glColor4f 0.0 0.0 0.0 1.0
	glPushMatrix
	glTranslatef -1 -2 -12 
	glBegin GL_LINES
        glColor4f 1.0 0.0 0.0 1.0
          glVertex3d 0.0 0.0 0.0 
          glVertex3d 1.0 0.0 0.0 
        glColor4f 0.0 1.0 0.0 1.0
          glVertex3d 0.0 0.0 0.0 
          glVertex3d 0.0 1.0 0.0 
        glColor4f 0.0 0.0 1.0 1.0
          glVertex3d 0.0 0.0 0.0 
          glVertex3d 0.0 0.0 1.0 
	  glEnd 
	glPopMatrix
	glEndList


set tempZrot 0
set tempXrot 0
set tempYrot 0
	
    } else {
	.gl makeCurrent

	catch {glDeleteLists $WorldCoord 1}
	glNewList $WorldCoord GL_COMPILE
	glColor4f 0.0 0.0 0.0 1.0
	glPushMatrix
	glMatrixMode GL_MODELVIEW 
	glLoadIdentity 
	glTranslatef -1 -2 -12 
	glBegin GL_LINES
        glColor4f 1.0 0.0 0.0 1.0
          glVertex3d 0.0 0.0 0.0 
          glVertex3d 1.0 0.0 0.0 
        glColor4f 0.0 1.0 0.0 1.0
          glVertex3d 0.0 0.0 0.0 
          glVertex3d 0.0 1.0 0.0 
        glColor4f 0.0 0.0 1.0 1.0
          glVertex3d 0.0 0.0 0.0 
          glVertex3d 0.0 0.0 1.0 
	  glEnd 
	glPopMatrix
	glEndList

	.gl2 makeCurrent

	catch {glDeleteLists $WorldCoord2 1}
	glNewList $WorldCoord2 GL_COMPILE
	glColor4f 0.0 0.0 0.0 1.0
	glPushMatrix
	glMatrixMode GL_MODELVIEW 
	glLoadIdentity 
	glTranslatef -1 -2 -12 
	glBegin GL_LINES
        glColor4f 1.0 0.0 0.0 1.0
          glVertex3d 0.0 0.0 0.0 
          glVertex3d 1.0 0.0 0.0 
        glColor4f 0.0 1.0 0.0 1.0
          glVertex3d 0.0 0.0 0.0 
          glVertex3d 0.0 1.0 0.0 
        glColor4f 0.0 0.0 1.0 1.0
          glVertex3d 0.0 0.0 0.0 
          glVertex3d 0.0 0.0 1.0 
	  glEnd 
	glPopMatrix
	glEndList

	.gl3 makeCurrent

	catch {glDeleteLists $WorldCoord3 1}
	glNewList $WorldCoord3 GL_COMPILE
	glColor4f 0.0 0.0 0.0 1.0
	glPushMatrix
	glMatrixMode GL_MODELVIEW 
	glLoadIdentity 
	glTranslatef -1 -2 -12 
	glBegin GL_LINES
        glColor4f 1.0 0.0 0.0 1.0
          glVertex3d 0.0 0.0 0.0 
          glVertex3d 1.0 0.0 0.0 
        glColor4f 0.0 1.0 0.0 1.0
          glVertex3d 0.0 0.0 0.0 
          glVertex3d 0.0 1.0 0.0 
        glColor4f 0.0 0.0 1.0 1.0
          glVertex3d 0.0 0.0 0.0 
          glVertex3d 0.0 0.0 1.0 
	  glEnd 
	glPopMatrix
	glEndList


set tempXrot [.l.x get]
set tempYrot [.l.y get]
set tempZrot [.l.z get]
   }
 .gl redraw
.gl2 redraw
.gl3 redraw
}

# orient it so the all cones point down
set xrot -84
set yrot 19
set zrot -90
Update $yrot
Update $xrot
Update $zrot





