#####
# Converted to Tkogl v3.0
# March/2001, by Group 5, EECE 285
# The University of British Columbia
#####

package require Tkogl
package require OpenGL
package require OpenGLU

set auto_index(Update) "source Util-update.tcl"


###########Generic Functions:

set Xeye 0 
set Yeye 0 
set Zeye 0 
set Xcenter 0
set Ycenter 0
set Zcenter -10
set storeZoomAngle 35
set storeOrthoZoom 2
set storeVarXpan  0
set storeVarYpan  0
set worldFlag 0
set projFlag 0
set tempXrot 0
set tempYrot 0
set tempZrot 0

################# for generic function uses  file generic1
source Util-generic1.tcl
 
 
########### the main widget 

pack [OGLwin .gl -width 850 -height 450 -refresh draw -doublebuffer 1]

################################################


proc displaytext  {color1 color2 color3 xposition yposition context} {
	global font
	global dlistsimon

set font [.gl createFont]
set dlistsimon [glGenLists 1]

	.gl makeCurrent

	catch {glDeleteLists $dlistsimon 1}
 	glNewList $dlistsimon GL_COMPILE
	glColor3f $color1 $color2 $color3
	glRasterPos2f $xposition $yposition
	.gl putString $font $context
#.gl eval
	glEndList
}
global font
set color1 0
set color2 0
set color3 0
set xposition -2
set font [.gl createFont]
set dlistsimon1 [glGenLists 1]
set dlistsimon2 [glGenLists 1]
set dlistsimon3 [glGenLists 1]
set dlistsimon4 [glGenLists 1]
set dlistsimon5 [glGenLists 1]


#.gl eval
	catch {glDeleteLists $dlistsimon1 1}
	glNewList $dlistsimon1 GL_COMPILE
	glColor3f $color1 $color2 $color3
	glRasterPos3f $xposition 1.9 0
	.gl putString $font "B1 FIELD APPLIED ALONG X' (rotating frame axis)"
#.gl eval
	glEndList

#.gl eval
	catch {glDeleteLists $dlistsimon2 1}
	glNewList $dlistsimon2 GL_COMPILE
	glColor3f $color1 $color2 $color3
	glRasterPos3f $xposition 1.75 0
	.gl putString $font "A 90O OR 270O FLIP GIVES THE LARGEST SIGNAL IN THE X'Y' PLANE"
#.gl eval
	glEndList
 
#.gl eval
	catch {glDeleteLists $dlistsimon3 1}
	glNewList $dlistsimon3 GL_COMPILE
	glColor3f $color1 $color2 $color3
	glRasterPos3f $xposition 1.6 0
	.gl putString $font "A 180O OR 360O FLIP GIVES NO SIGNAL"
#.gl eval
	glEndList
#.gl eval
	catch {glDeleteLists $dlistsimon4 1}
	glNewList $dlistsimon4 GL_COMPILE
	glColor3f $color1 $color2 $color3
	glRasterPos3f $xposition 1.45 0
	.gl putString $font "Rem: B1 FIELD MUST BE OSCILLATING AT OR NEAR THE LARMOR FREQUENCY"
#.gl eval
	glEndList 
#.gl eval
	catch {glDeleteLists $dlistsimon5 1}
	glNewList $dlistsimon5 GL_COMPILE
	glColor3f $color1 $color2 $color3
	glRasterPos3f $xposition 1.3 0
	.gl putString $font "OF THE NUCLEI TO AFFECT THE TIP (ie. RESONANCE) OF THE BULK MAGNETIZATION, M0" 
#.gl eval
	glEndList
###################################################


update idletasks

# display lists for cones
set cone [.gl cylinder 0 1 0 20 1]
set arrow [.gl cylinder 0 0.08 0.15 14 3]
#list of objects 

set objectcone [glGenLists 1]
set vectorobj [glGenLists 1]
set WorldCoord [glGenLists 1]
set objectarrow [glGenLists 1]

set Shift -10
set xcCone1 0
set ycCone1 0
set zcCone1 0

set phase1 90 


proc DrawCone { val } {
       global objectcone cone xcCone1 ycCone1 zcCone1 Shift

	.gl makeCurrent

	catch {glDeleteLists $objectcone 1}
       	glNewList $objectcone GL_COMPILE
	glColor4f 0.0 1.0 1.0 $val
             glPushMatrix
                glTranslatef 0 0 $Shift
                glCallList $cone
             glPopMatrix
	glEndList
       .gl redraw
}

#creating arrow head for the vectors
proc DrawArrow { degree } {

      global objectarrow Shift arrow coordx1 coordy1 coordz1
	    
	.gl makeCurrent

	catch {glDeleteLists $objectarrow 1}
	glNewList $objectarrow GL_COMPILE
	glColor3f 0.0 0.0 0.0
            glPushMatrix
		glTranslatef $coordx1 $coordy1 [expr $coordz1 + $Shift]
		glRotatef -$degree 1 0 0 
		glRotatef 180 1 0 0
		glCallList $arrow
	    glPopMatrix
	glEndList

       .gl redraw
}



DrawCone 0.3


#seting up the rotational vector   
proc vectordraw { angle } {

        global vectorobj ang phase1 xcCone1 ycCone1 zcCone1 Shift
	global flagA flagB flagC coordx1 coordy1 coordz1 angglobal

set angglobal $angle
set ang $angle
set v_radius 1
set h 1

#this is for part 1 

for {set i 1} {$i<2} {incr i} { 

set ang $angle
set arrowAng $ang
set coordx$i 0 
set coordy$i [expr {$v_radius * [expr sin(($ang)*3.141592654/180)]}]
set coordz$i [expr {$v_radius * [expr cos(($ang)*3.141592654/180)]}]
}
DrawArrow $arrowAng

	catch {glDeleteLists $verctorobj 1}
	glNewList $vectorobj GL_COMPILE
	glColor4f 0 0 0 1.0
	glPushMatrix
		glDepthMask 1
		glLineWidth 4
		glTranslatef 0 0 $Shift
		glBegin GL_LINES
			glVertex3d 0 0 0
			glVertex3f $coordx1 $coordy1 $coordz1
		glEnd
		glLineWidth 3
		glBegin GL_LINES
			glVertex3f 0 0 0
			glVertex3f $coordx1 $coordy1 0
		glEnd
		glEnable GL_LINE_STIPPLE
		glLineStipple 1 0x8888
		glLineWidth 2 
		glBegin GL_LINES
			glVertex3f $coordx1 $coordy1 $coordz1
			glVertex3f $coordx1 $coordy1 0
		glEnd
		glDisable GL_LINE_STIPPLE
		glLineWidth 3
		glDepthMask 0
		glPopMatrix
       .gl redraw

eval lappend l 
}



#create a switch for fan out(in xy plane from 0 to 30 deg)
frame .m -bg blue3 -width 200 -height 300
frame .m.rotate 

button .m.rotate.part1 -command {startRotate1 [.m.rotate.amount get]} -text "Rotate"
label .m.rotate.angle -text "Enter the flip angle, and then press the 'Rotate' button "
entry .m.rotate.amount -width 4
frame .m.rotstatus






pack .m.rotate.angle .m.rotate.amount -side top -padx 3 -pady 3 
pack .m.rotate.part1
pack .m.rotate -side top -padx 3 -pady 3  
pack .m.rotstatus -padx 3 -pady 3  


########for button 1 flipping by the given angle

set startAngle1 0
set finishAngle1 0
set currentAng1 0

proc startRotate1 {deg} {
    global ang startAngle1 finishAngle1 currentAng1

set currentAng1 0
set finishAngle1 [expr $currentAng1 + $deg]

    rotateVector1 1
}

proc rotateVector1 {amount} {
global startAngle1 finishAngle1 vectorobj1 currentAng1 flagB
        vectordraw $currentAng1

    if {$currentAng1 < $finishAngle1} {
         incr currentAng1 $amount
		after 1 "rotateVector1 1"
    } else {
       set startAngle1 $currentAng1
    }

}


frame .m.f
label .m.f.l -text "Transparency"
scale .m.f.cone1 -from 0 -to 1 -resolution 0.01 -label "first cone" -command  DrawCone -orient horizontal

# creating a scale to change the position of the vector on the cone
pack .m.f -side bottom -padx 3 -pady 3 
pack .m.f.l -side top -padx 3 -pady 3  
pack .m.f.cone1 -side left -padx 3 -pady 3 


.m.f.cone1 set 0.3



proc draw {} {

	global Shift vectorobj objectcone objectarrow WorldCoord
	global dlistsimon1 dlistsimon2 dlistsimon3 dlistsimon4 dlistsimon5

	.gl makeCurrent

	glEnable GL_BLEND
     	glEnable GL_DEPTH_TEST
	glEnable GL_LINE_SMOOTH
     	glClear GL_COLOR_BUFFER_BIT
	glClear GL_DEPTH_BUFFER_BIT
	glLineWidth 2
	glPushMatrix
	glTranslatef 0 0 $Shift
	glBegin GL_LINES
         glColor4f 1.0 0.0 0.0 0.2
          glVertex3f 0.0 0.0 0.0
	  glVertex3f 1.0 0.0 0.0
	 glColor4f 0.0 1.0 0.0 1.0
          glVertex3f 0.0 0.0 0.0
          glVertex3f 0.0 1.0 0.0
         glColor4f 0.0 0.0 1.0 1.0
          glVertex3f 0.0 0.0 0.0
          glVertex3f 0.0 0.0 1.0
	glEnd
	glLineWidth 3
	glPopMatrix
	glClearColor 1.0 1.0 1.0 0.1
	glCallList $vectorobj
	glCallList $objectcone
	glCallList $objectarrow
	glCallList $WorldCoord
	glLoadIdentity
	glCallList $dlistsimon1
	glCallList $dlistsimon2
	glCallList $dlistsimon3
	glCallList $dlistsimon4
	glCallList $dlistsimon5
	glLoadIndentity

	.gl swapBuffer

}

#rotational bindings and functions
# default manipulations
bind .gl <Button-1> { set x %x ; set y %y }
bind .gl <B1-Motion> {
    incr xrot [expr %x - $x]
    incr yrot [expr %y - $y]
    set x %x
    set y %y

	Update $zrot
	Update $yrot
	Update $xrot 
	
}

set zrot 0
bind .gl <Button-3> { set z %x }
bind .gl <B3-Motion> {

    incr zrot [expr %x - $z]
    set z %x

Update $zrot
Update $yrot
Update $xrot
}

scale .x -from -180 -to 180 -command "rotate x" -variable yrot -label X
scale .y -from -180 -to 180 -command "rotate y" -variable xrot -label Y
scale .z -from -180 -to 180 -command "rotate z" -variable zrot -label Z

proc rotate {ax val} {
   
    global zrot yrot xrot 

Update $zrot
Update $yrot
Update $xrot
}

pack .x .y .z -side left -padx 3 -pady 3 




# orient it so the all cones point down
set xrot -72
set yrot 17
set zrot -90
Update $yrot
Update $xrot
Update $zrot

pack .m  

