######
# Converted to Tkogl v3.0
# March/2001, by group 5, EECE 285
# The University of British Columbia
#####

package require Tkogl
package require OpenGL
package require OpenGLU

###########Generic Functions:
set Xeye 0 
set Yeye 0 
set Zeye 10 
set Xcenter 0
set Ycenter 0
set Zcenter 0
set storeZoomAngle 35
set storeOrthoZoom 4
set storeVarXpan  0
set storeVarYpan  0
set worldFlag 0
set projFlag 0
set Shift 0
set v0x -1 
set v0y 1 
set v0z 0 
set v2x 1 
set v2y -1 
set v2z 0 
set pickvtx 0

frame .camset -bg blue3 -width 200 -height 300

#zoom scale using perspective projection
scale .camset.perspect -from 5 -to 175 -resolution 1 -label "Perspective Zoom" -command Update \
-variable zoomAngle -orient horizontal

#zoom using Ortho projection
scale .camset.ortho -from 1 -to 40 -resolution 1 -label "Ortho Zoom" -command Update \
-variable orthoZoom -orient horizontal


#pan scale
scale .camset.panx -from -40 -to 40 -resolution 1 -label "pan X" -command panX \
-variable varXpan -orient horizontal
scale .camset.pany -from -40 -to 40 -resolution 1 -label "pan Y" -command panY \
-variable varYpan -orient horizontal

#Home
button .camset.home -command setHome -text "Home"

#initial condition
button .camset.initial -command initial -text "Initial condition"

# store view point 
button .camset.currentView -command storeView -text "set viewpoint"
# go to the stored view point
button .camset.gotoView -command GotoView -text "Go to set viewpoint"

#world coordinate flag
button .camset.worldFlag -command WorldCoord -text "Set World coord"

#projection condition 
button .camset.projFlag -command Projection -text "Change projection mode"

#camera scales
scale .camset.eyex -from -50 -to 50 -resolution 1 -label "X eye" -command Update \
-variable Xeye -orient horizontal
scale .camset.eyey -from -50 -to 50 -resolution 1 -label "Y eye" -command Update \
-variable Yeye -orient horizontal
scale .camset.eyez -from -50 -to 50 -resolution 1 -label "Z eye" -command Update \
-variable Zeye -orient horizontal
scale .camset.centerx -from -50 -to 50 -resolution 1 -label "X Center" -command Update \
-variable Xcenter -orient horizontal
scale .camset.centery -from -50 -to 50 -resolution 1 -label "Y Center" -command Update \
-variable Ycenter -orient horizontal
scale .camset.centerz -from -50 -to 50 -resolution 1 -label "Z Center" -command Update \
-variable Zcenter -orient horizontal

.camset.perspect set 35
.camset.ortho set 4



pack .camset.worldFlag -side top -padx 3 -pady 3 
pack .camset.home -side top -padx 3 -pady 3
pack .camset.initial -side top -padx 3 -pady 3
pack .camset.currentView -side top -padx 3 -pady 5
pack .camset.gotoView -side top -padx 3 -pady 5 
pack .camset.panx -side top -padx 3 -pady 3 
pack .camset.pany -side top -padx 3 -pady 3
pack .camset.projFlag -side top -padx 3 -pady 3 
pack .camset.ortho -side top -padx 3 -pady 3


pack .camset -side right 
label .h -bg blue3 -width 200 -height 300

#button .h.showcalculations -text "Show numerical values" -command DoCalc
#pack .h.showcalculations -side left -padx 3 -pady 5

label .h.text -text "A is the red vector & B is the Blue vector. \
	The green vector C is projection of A over B"
label .h.vectorA
label .h.vectorB 
label .h.vectorA.a -text "Magnitude of vector A ="
label .h.vectorA.amagnitude -textvariable MagA -width 14
label .h.vectorB.b -text "Magnitude of vector B ="
label .h.vectorB.bmagnitude -textvariable MagB -width 14

label .h.angle
label .h.angle.text -text "Angle between vectors A and B = " 
label .h.angle.amount -textvariable Ang -width 14
label .h.result
label .h.result.text -text "Dot product is  ' A.B ' = "
label .h.result.amount -textvariable dotResult -width 14
pack .h.text -side top -padx 3 -pady 5
pack .h.vectorA.a .h.vectorA.amagnitude -side left
pack .h.vectorB.b .h.vectorB.bmagnitude -side left 
pack .h.angle.text .h.angle.amount -side left 
pack .h.result.text .h.result.amount -side left 
pack .h.vectorA .h.vectorB -side top -padx 3 -pady 5
pack .h.result .h.angle -padx 3 -pady 5


proc panX {var} {
global Xeye Xcenter varXpan 

set Xeye $varXpan 
set Xcenter $varXpan

Update $Xeye
Update $Xcenter

}

proc panY {var} {
global Yeye Ycenter varYpan 

set Yeye $varYpan 
set Ycenter $varYpan

Update $Yeye
Update $Ycenter

}

#going back to home
proc setHome {} {
global projFlag Shift

set Shift 0

if {$projFlag == 0} {
.camset.ortho set 4
} else {
.camset.perspect set 35
}
.camset.panx set 0
.camset.pany set 0
}

#set everything to the initial condition  
 proc initial {} {

global projFlag Shift worldFlag vtx 


set Shift 0
set worldFlag 0

if {$projFlag == 0} {
.camset.ortho set 4
} else {
.camset.perspect set 35
}
.camset.panx set 0
.camset.pany set 0 
.h.x set 180
.h.y set 0
.h.z set 0
set vtx(0) "1.0 -1.5 0.0"
set vtx(1) "0.0 0.0 0.0"
set vtx(2) "1.6 0.0 0.0"
compute_picture
}

##storing the current view point
 
proc storeView {} {
global zoomAngle orthoZoom varXpan  varYpan
global storeZoomAngle storeOrthoZoom storeVarXpan storeVarYpan  

set storeZoomAngle $zoomAngle 
set storeOrthoZoom $orthoZoom 
set storeVarXpan  $varXpan  
set storeVarYpan  $varYpan  

}

##going back to the stored view point
proc  GotoView {} {
global storeZoomAngle storeOrthoZoom storeVarXpan storeVarYpan  projFlag

if {$projFlag == 0} {
.camset.ortho set $storeOrthoZoom
} else {
.camset.perspect set $storeZoomAngle
}
.camset.panx set $storeVarXpan 
.camset.pany set $storeVarYpan 

}

#setting up the flag that indicates what kind of world coordinate we want(fixed to not). 
proc WorldCoord {} {
global worldFlag

if {$worldFlag == 0} {
set worldFlag 1
} else {
set worldFlag 0
}

Update worldFlag
} 



#choosing perspective or ortho projection
proc Projection {} {
global projFlag 

if {$projFlag == 0} {
set projFlag 1
catch {destroy .camset.ortho}
catch {destroy .camset.perspect} 

scale .camset.perspect -from 5 -to 175 -resolution 1 -label "Perspective Zoom" -command Update \
-variable zoomAngle -orient horizontal
pack .camset.perspect -side top -padx 3 -pady 3

} else {
set projFlag 0
catch {destroy .camset.perspect}

scale .camset.ortho -from 1 -to 40 -resolution 1 -label "Ortho Zoom" -command Update \
-variable orthoZoom -orient horizontal
pack .camset.ortho -side top -padx 3 -pady 3

}

Update projFlag
} 

 
########### the main widget 

pack [OGLwin .gl -width 450 -height 400 -refresh mainproc -doublebuffer 1]


update idletasks

# display lists for cones
#list of objects 
set WorldCoord [glGenLists 1]
set l [ glGenLists 1 ]

set vtx(0) "1.0 -1.5 0.0"
set vtx(1) "0.0 0.0 0.0"
set vtx(2) "1.6 0.0 0.0"

#frame .f -bg blue3 -width 200 -height 300

#scale .f.angle -from 0 -to 180 -resolution 1 -label "Angle" -command setAngle \
#-variable angleset -orient horizontal

#pack .f.angle -side top -padx 3 -pady 3
#pack .f -side bottom


#proc setAngle {val} {
#global Dangle 
#compute_picture
#set .f.angle $Dangle
#set $Dangle val 
#}
###########showing the direction of the cross product using a small cone.


#set up the object
proc compute_picture {} {
    global Dangle vtx picture pickvtx v0x v0y v0z v2x v2y v2z dotResult
    global Ang MagA MagB AngA AngB l

puts "compute-Picture is called and vtx($pickvtx) is : $vtx($pickvtx)"

set v0x [lindex $vtx(0) 0] 
set v0y [lindex $vtx(0) 1] 
set v0z [lindex $vtx(0) 2] 
set v2x [lindex $vtx(2) 0] 
set v2y [lindex $vtx(2) 1] 
set v2z [lindex $vtx(2) 2] 

puts "v0: $v0x $v0y $v0z "
puts "v2: $v2x $v2y $v2z "

set prod [expr ($v0x * $v2x) + ($v0y * $v2y) + ($v0z * $v2z)]
puts "Dot prod is $prod "

#to choose the sign of the angle
set Dir [expr ($v2x * $v0y) - ($v2y * $v0x)]
set DirA [expr -$v0y]
set DirB [expr -$v2y]

set dotResult $prod

set V0 [expr sqrt(( $v0x * $v0x ) + ($v0y * $v0y) + ($v0z * $v0z))]
set V2 [expr sqrt(( $v2x * $v2x ) + ($v2y * $v2y) + ($v2z * $v2z))]

set MagA $V0
set MagB $V2

puts "magnitude of V0 is $V0 and  V2 is $V2"

set anglePi [expr acos ($prod /($V0 * $V2))]
set angleD [expr $anglePi * 180 /3.141592654 ]

puts "anglePi is $anglePi and angle in Degrees is $angleD"

set anglePiA [expr acos ($v0x /$V0)]
set angleA [expr $anglePiA * 180 /3.141592654 ]

set anglePiB [expr acos ($v2x /$V2)]
set angleB [expr $anglePiB * 180 /3.141592654 ]


if {$Dir < 0 } {
set Ang $angleD
} else {
set Ang [expr ($angleD * -1)]
}
if {$DirA < 0 } {
set AngA $angleA
} else {
set AngA [expr ($angleA * -1)]
}
if {$DirB < 0 } {
set AngB $angleB
} else {
set AngB [expr ($angleB * -1)]
}



set proj [expr {$V0 * cos($angleD * 3.141592654 / 180)}]

set cosAngA [expr {0.25 * cos($AngA * 3.141592654 / 180)}]
set sinAngA [expr {0.25 * sin($AngA * 3.141592654 / 180)}]
set cosAngB [expr {0.25 * cos($AngB * 3.141592654 / 180)}]
set sinAngB [expr {0.25 * sin($AngB * 3.141592654 / 180)}]

set dirXproj [expr $v2x / $V2]
set dirYproj [expr $v2y / $V2]
set dirZproj [expr $v2z / $V2]
set Xproj [expr $proj * $dirXproj]
set Yproj [expr $proj * $dirYproj]
set Zproj [expr $proj * $dirZproj]


#lines
	set lines [ glGenLists 1 ]

	catch { glDeleteLists $lines 1 }
	glNewList $lines GL_COMPILE
	glEnable GL_LINE_STIPPLE
	glLineStipple 1 0x8888
	glLineWidth 3
	glBegin GL_LINES
	  glColor3f 0.0 0.0 0.0
	  glVertex3d $v0x $v0y 0
	  glVertex3d $Xproj $Yproj 0
	glEnd
	glDisable GL_LINE_STIPPLE
	glDepthMask 1
	glLineWidth 5
	glBegin GL_LINES
	  glColor3f 0.1 0.6 0.4
	  glVertex3d 0.0 0.0 0.0
	  glVertex3d $Xproj $Yproj 0
	glEnd
	glDepthMask 0
	glLineWidth 3
	glColor3f 1 0 0
	glBegin GL_LINES
	  glVertex3d $v0x $v0y 0
	  glVertex3d 0.0 0.0 0.0
	glEnd
	glLineWidth 3
	glColor3f 1 0 0
	glBegin GL_TRIANGLES
	glVertex3f $v0x $v0y 0
	glVertex3f [expr $v0x - $cosAngA + $sinAngA ] [expr $v0y - $sinAngA - $cosAngA] 0
	glVertex3f [expr $v0x - $cosAngA - $sinAngA ] [expr $v0y - $sinAngA + $cosAngA] 0
	glEnd
	glLineWidth 3
	glColor3f 0.1 0.3 0.9
	glBegin GL_LINES
	  glVertex3d 0.0 0.0 0.0
	  glVertex3d $v2x $v2y 0
	glEnd
	glLineWidth 3
	glColor3f 0.1 0.3 0.9
	glBegin GL_TRIANGLES
	  glVertex3d $v2x $v2y 0
	  glVertex3d [expr $v2x - $cosAngB + $sinAngB ] [expr $v2y - $sinAngB - $cosAngB] 0
	  glVertex3d [expr $v2x - $cosAngB - $sinAngB ] [expr $v2y - $sinAngB + $cosAngB] 0
	glEnd
	glEndList


#points	
	set points [ glGenLists 1 ]

	catch { glDeleteLists $points 1 }
	glNewList $points GL_COMPILE
	glDepthMask 1
	glInitNames
	glPushName -1
	glPointSize 5 
	glLoadName 2
	glBegin GL_POINTS
	  glColor3f 0.0 0.0 0.0
	  glVertex3d $v2x $v2y 0
	glEnd
	glPopName
	glInitNames
	glPushName -1
	glPointSize 5 
	glLoadName 0
	glBegin GL_POINTS
	 glColor3f 0.0 0.0 0.0
	 glVertex3f $v0x $v0y 0
	glEnd
	glPopName
	glDepthMask 0
	glColor4f 0.0 0.1 0.2 0.1 
	glBegin GL_POLYGON
		glVertex3d 2 2 0
		glVertex3d -2 2 0
		glVertex3d -2 -2 0
		glVertex3d 2 -2 0
		glVertex3d 2 2 0
	glEnd
	glEndList
	
	set picture [ glGenLists 1 ]

	catch { glDeleteLists $picture 1 }
	glNewList $picture GL_COMPILE
    	glCallList $l
	glCallList $lines
	glCallList $points
	glEndList

	
}
compute_picture 



proc mainproc {} {

global picture WorldCoord objectcone objectcone3 objectcone4 objectcone5 

	.gl makeCurrent

	glEnable GL_BLEND
      	glEnable GL_DEPTH_TEST
	glEnable GL_LINE_SMOOTH
      	glClear GL_COLOR_BUFFER_BIT
	glClear GL_DEPTH_BUFFER_BIT
	glClearColor 1.0 1.0 1.0 0.1
	glCallList $WorldCoord
	glCallList $picture 

	.gl swapBuffer
}	
	

#rotational bindings and functions
# default manipulations
bind .gl <Button-1> { set x %x ; set y %y }
bind .gl <B1-Motion> {
    incr xrot [expr %x - $x]
    incr yrot [expr %y - $y]
    set x %x
    set y %y

	Update $zrot
	Update $yrot
	Update $xrot 
	
}

set zrot 0
#bind .gl <Button-3> { set z %x }
#bind .gl <B2-Motion> {

  #  incr zrot [expr %x - $z]
  #  set z %x

#Update $zrot
#Update $yrot
#Update $xrot
#}

scale .h.x -from -180 -to 180 -command "rotate x" -variable yrot -label X
scale .h.y -from -180 -to 180 -command "rotate y" -variable xrot -label Y
scale .h.z -from -180 -to 180 -command "rotate z" -variable zrot -label Z

proc rotate {ax val} {
   
    global zrot yrot xrot 

Update $zrot
Update $yrot
Update $xrot
}

pack .h.x .h.y .h.z -side left -padx 3 -pady 5
pack .h 

proc Update {var} {

global xrot yrot zrot Shift zoomAngle Xeye Yeye Zeye Xcenter Ycenter
global Zcenter orthoZoom worldFlag WorldCoord projFlag tempZrot
global tempYrot tempXrot picture vtx pickvtx pickz x y


if {$projFlag == 0} {

	.gl makeCurrent

	glEnable GL_BLEND
	glEnable GL_DEPTH_TEST
      	glBlendFunc GL_SRC_ALPHA GL_ONE_MINUS_SRC_ALPHA
 	glMatrixMode GL_PROJECTION
	glLoadIdentity
	glOrtho [expr -$orthoZoom] $orthoZoom  [expr -$orthoZoom] $orthoZoom  -20 20
	glMatrixMode GL_MODELVIEW
	glLoadIdentity
	gluLookAt $Xeye $Yeye $Zeye $Xcenter $Ycenter $Zcenter 0 1 0
	glTranslatef 0 0 $Shift
	glRotatef $zrot 0 0 1
	glRotatef $yrot 1 0 0
	glRotatef $xrot 0 1 0
	glTranslatef 0 0 [expr -$Shift]
} else {
	.gl makeCurrent

	glEnable GL_BLEND
      	glEnable GL_DEPTH_TEST
      	glBlendFunc GL_SRC_ALPHA GL_ONE_MINUS_SRC_ALPHA
	glMatrixMode GL_PROJECTION
	glLoadIdentity
	gluPerspective $zoomAngle 1 0.1 50
	glMatrixMode GL_MODELVIEW
	glLoadIdentity
	gluLookAt $Xeye $Yeye $Zeye $Xcenter $Ycenter $Zcenter 0 1 0
	glTranslatef 0 0 $Shift
	glRotatef $zrot 0 0 1
	glRotatef $yrot 1 0 0
	glRotatef $xrot 0 1 0
	glTranslatef 0 0 [expr -$Shift]
}


 if {$worldFlag == 1 } {

	catch {glDeleteLists $WorldCoord 1}
	glNewList $WorldCoord GL_COMPILE
	glColor4f 0.0 0.0 0.0 1.0
	glPushMatrix
	glTranslatef -2 -3 -3
	glBegin GL_LINES
	 glColor4f 1.0 0.0 0.0 1.0
          glVertex3f 0.0 0.0 0.0
          glVertex3f 1.0 0.0 0.0
	 glColor4f 0.0 1.0 0.0 1.0
          glVertex3f 0.0 0.0 0.0
          glVertex3f 0.0 1.0 0.0
         glColor4f 0.0 0.0 1.0 1.0
          glVertex3f 0.0 0.0 0.0
          glVertex3f 0.0 0.0 1.0
	glEnd
	glPopMatrix
	glEndList

    } else {

	.gl makeCurrent

	catch {glDeleteLists $WorldCoord 1}
	glNewList $WorldCoord GL_COMPILE
	glColor4f 0.0 0.0 0.0 1.0
	glPushMatrix
	glMatrixMode GL_MODELVIEW
	glLoadIdentity
	glTranslatef -2 -3 -3
	glBegin GL_LINES
        glColor4f 1.0 0.0 0.0 1.0
          glVertex3f 0.0 0.0 0.0
          glVertex3f 1.0 0.0 0.0
        glColor4f 0.0 1.0 0.0 1.0
          glVertex3f 0.0 0.0 0.0
          glVertex3f 0.0 1.0 0.0
        glColor4f 0.0 0.0 1.0 1.0
          glVertex3f 0.0 0.0 0.0
          glVertex3f 0.0 0.0 1.0
	  glEnd
	glPopMatrix
	glEndList
  }

.gl redraw
}


proc pick_point { x y } {
global pickvtx pickz vtx orthoZoom picture

	catch { glDeleteLists $l 1 }
	glNewList $l GL_COMPILE
	.gl Select 100
	glMatrixMode GL_PROJECTION
	glPushMatrix
	glLoadIdentity
	glPickMatrix $x $y 6 6
	glOrtho [expr -$orthoZoom] $orthoZoom  [expr -$orthoZoom] $orthoZoom  -20 20
        glMatrixMode GL_MODELVIEW
        glCallList $picture
	glMatrixMode GL_PROJECTION
	glPopMatrix
	glEndList

puts "l $l"
    set pickvtx {}
    puts $l
    foreach hit $l {
	set pickvtx [lindex $hit 3]
		if {$pickvtx=={}} continue
	puts "pickvtx $pickvtx"
	set pickz [lindex $hit 1] 
	puts "pickz $pickz"
	puts "pick point $x $y"
	puts "vtx $pickvtx"
	puts "world coords $vtx($pickvtx)"
	puts "window coords [eval .gl project $vtx($pickvtx)]"
	break
}

}

proc move_point { x y } {
	
	puts "inside move-point"
    global pickvtx pickz vtx
    if {$pickvtx=={}} return
    set vtx($pickvtx) [.gl unproject $x $y $pickz]
    puts "unprojected vtx($pickvtx) $vtx($pickvtx)"
    compute_picture
    mainproc
 Update dummy 
  }

bind .gl <Button-3> { pick_point %x %y ; set z %x}
bind .gl <B3-Motion> {

move_point %x %y 
}
mainproc

# orient it so the all cones point down
set xrot 0
set yrot 180
set zrot 0
set x 0
set y 0
Update $yrot
Update $xrot
