
frame .camset -bg blue3 -width 200 -height 300

#zoom scale using perspective projection
scale .camset.perspect -from 5 -to 175 -resolution 1 -label "Perspective Zoom" -command Update \
-variable zoomAngle -orient horizontal

#zoom using Ortho projection
scale .camset.ortho -from 1 -to 40 -resolution 1 -label "Ortho Zoom" -command Update \
-variable orthoZoom -orient horizontal


#pan scale
scale .camset.panx -from -40 -to 40 -resolution 1 -label "pan X" -command panX \
-variable varXpan -orient horizontal
scale .camset.pany -from -40 -to 40 -resolution 1 -label "pan Y" -command panY \
-variable varYpan -orient horizontal

#Home
button .camset.home -command setHome -text "Home"

#initial condition
button .camset.initial -command initial -text "Initial condition"

# store view point 
button .camset.currentView -command storeView -text "set viewpoint"
# go to the stored view point
button .camset.gotoView -command GotoView -text "Go to set viewpoint"

#world coordinate flag
button .camset.worldFlag -command WorldCoord -text "Set World coord"

#projection condition 
button .camset.projFlag -command Projection -text "Change projection mode"

#camera scales
scale .camset.eyex -from -50 -to 50 -resolution 1 -label "X eye" -command Update \
-variable Xeye -orient horizontal
scale .camset.eyey -from -50 -to 50 -resolution 1 -label "Y eye" -command Update \
-variable Yeye -orient horizontal
scale .camset.eyez -from -50 -to 50 -resolution 1 -label "Z eye" -command Update \
-variable Zeye -orient horizontal
scale .camset.centerx -from -50 -to 50 -resolution 1 -label "X Center" -command Update \
-variable Xcenter -orient horizontal
scale .camset.centery -from -50 -to 50 -resolution 1 -label "Y Center" -command Update \
-variable Ycenter -orient horizontal
scale .camset.centerz -from -50 -to 50 -resolution 1 -label "Z Center" -command Update \
-variable Zcenter -orient horizontal

.camset.perspect set 35
.camset.ortho set 2

pack .camset.worldFlag -side top -padx 3 -pady 3 
pack .camset.home -side top -padx 3 -pady 3
pack .camset.initial -side top -padx 3 -pady 3
pack .camset.currentView -side top -padx 3 -pady 5
pack .camset.gotoView -side top -padx 3 -pady 5 
pack .camset.panx -side top -padx 3 -pady 3 
pack .camset.pany -side top -padx 3 -pady 3
pack .camset.projFlag -side top -padx 3 -pady 3 
pack .camset.ortho -side top -padx 3 -pady 3


pack .camset -side right 

proc panX {var} {
global Xeye Xcenter varXpan 

set Xeye $varXpan 
set Xcenter $varXpan

Update $Xeye
Update $Xcenter

}

proc panY {var} {
global Yeye Ycenter varYpan 

set Yeye $varYpan 
set Ycenter $varYpan

Update $Yeye
Update $Ycenter

}

#going back to home
proc setHome {} {
global projFlag Shift

set Shift -10

if {$projFlag == 0} {
.camset.ortho set 2
} else {
.camset.perspect set 35
}
.camset.panx set 0
.camset.pany set 0
}

#set everything to the initial condition  
 proc initial {} {

global projFlag Shift tempXrot tempYrot tempZrot worldFlag 

set Shift -10
set worldFlag 0

if {$projFlag == 0} {
.camset.ortho set 2
} else {
.camset.perspect set 35
}
.camset.panx set 0
.camset.pany set 0 
.x set 17 
.y set -72
.z set -90

}

##storing the current view point
 
proc storeView {} {
global zoomAngle orthoZoom varXpan  varYpan \
storeZoomAngle storeOrthoZoom storeVarXpan storeVarYpan  

set storeZoomAngle $zoomAngle 
set storeOrthoZoom $orthoZoom 
set storeVarXpan  $varXpan  
set storeVarYpan  $varYpan  

}

##going back to the stored view point
proc  GotoView {} {
global storeZoomAngle storeOrthoZoom storeVarXpan storeVarYpan  projFlag

if {$projFlag == 0} {
.camset.ortho set $storeOrthoZoom
} else {
.camset.perspect set $storeZoomAngle
}
.camset.panx set $storeVarXpan 
.camset.pany set $storeVarYpan 

}

#setting up the flag that indicates what kind of world coordinate we want(fixed to not). 
proc WorldCoord {} {
global worldFlag

if {$worldFlag == 0} {
set worldFlag 1
} else {
set worldFlag 0
}

Update worldFlag
} 



#choosing perspective or ortho projection
proc Projection {} {
global projFlag 

if {$projFlag == 0} {
set projFlag 1
catch {destroy .camset.ortho}
catch {destroy .camset.perspect} 

scale .camset.perspect -from 5 -to 175 -resolution 1 -label "Perspective Zoom" -command Update \
-variable zoomAngle -orient horizontal
pack .camset.perspect -side top -padx 3 -pady 3

} else {
set projFlag 0
catch {destroy .camset.perspect}

scale .camset.ortho -from 1 -to 40 -resolution 1 -label "Ortho Zoom" -command Update \
-variable orthoZoom -orient horizontal
pack .camset.ortho -side top -padx 3 -pady 3

}

Update projFlag
} 

 
