######
# Converted to run with Tkogl v3.0
# Feb/2001, by EECE 285, group 5
# The University of British Columbia (UBC)
######

package require Tkogl
package require OpenGL
package require OpenGLU

catch { destroy .gl }
pack [OGLwin .gl -refresh draw]


.gl makeCurrent

glMatrixMode GL_PROJECTION
glLoadIdentity
glOrtho -1 1 -1 1 -1 1

proc draw {} {

    glClear GL_COLOR_BUFFER_BIT

    glColor3f 1 0 0
    glBegin GL_LINES
    glVertex3d 0.0 0.0 0.0
    glVertex3d 1.0 0.0 0.0
    glEnd
    glColor3f 0 1 0
    glBegin GL_LINES
    glVertex3d 0.0 0.0 0.0 
    glVertex3d 0.0 1.0 0.0
    glEnd
    glColor3f 0 0 1
    glBegin GL_LINES
    glVertex3d 0.0 0.0 0.0
    glVertex3d 0.0 0.0 1.0
    glEnd

    .gl swapBuffer

}
# set up rotation bindings

set xrot 0
set yrot 0
set pmode fill

bind .gl <Button-1> { set x %x ; set y %y }
bind .gl <B1-Motion> { 
    incr xrot [expr %x - $x] 
    incr yrot [expr %y - $y] 
    set x %x
    set y %y
 
    .gl makeCurrent

    glMatrixMode GL_MODELVIEW
    glLoadIdentity
    glRotatef $zrot 0 0 1
    glRotatef $yrot 1 0 0 
    glRotatef $xrot 0 1 0

    .gl redraw
}


set zrot 0
bind .gl <Button-3> { set z %x }
bind .gl <B3-Motion> { 

    incr zrot [expr %x - $z] 
    set z %x

    .gl makeCurrent

    glMatrixMode GL_MODELVIEW
    glLoadIdentity
    glRotatef $zrot 0 0 1
    glRotatef $yrot 1 0 0
    glRotatef $xrot 0 1 0

    .gl redraw
}

scale .x -from -180 -to 180 -command "rotate x" -variable yrot -label X
scale .y -from -180 -to 180 -command "rotate y" -variable xrot -label Y
scale .z -from -180 -to 180 -command "rotate z" -variable zrot -label Z


set xrotoff 0
set yrotoff 0
set zrotoff 0

proc rotate {ax val} {
    
    global zrot yrot xrot

    .gl makeCurrent
    
    glMatrixMode GL_MODELVIEW
    glLoadIdentity
    glRotatef $zrot 0 0 1
    glRotatef $yrot 1 0 0 
    glRotatef $xrot 0 1 0

    .gl redraw
}

pack .x .y .z -side left

 


