#####
#Converted to Tkogl v3.0
#March/2001, by group 5, EECE 285
#The University of British Columbia
#####

package require Tkogl
package require OpenGL
package require OpenGLU

###########Generic Functions:

set Xeye 0 
set Yeye 0 
set Zeye 0 
set Xcenter 0
set Ycenter 0
set Zcenter -10
set storeZoomAngle 35
set storeOrthoZoom 2
set storeVarXpan  0
set storeVarYpan  0
set worldFlag 0
set projFlag 0
set tempXrot 0
set tempYrot 0
set tempZrot 0

set xarrowB0 0
set yarrowB0 0
set zarrowB0 0
set xarrowB1 0
set yarrowB1 0
set zarrowB1 0
set degree 0
set flagA 0
set flagB 0
set newRadius [expr sqrt(2)]


################# for generic function uses  file generic2
source Util-generic2.tcl
########### the main widget 
#GL2
    
pack [OGLwin .gl2 -refresh draw -width 300 -height 300 -doublebuffer 1] -side right

update idletasks

# display lists for cones and circles and arrows


#GL2
set cone2 [.gl2 cylinder 0 $newRadius 0.01 40 40]
set arrow2 [.gl2 cylinder 0 0.08 0.15 15 15]




#gl2
set objectcone2 [glGenLists 1]
set vectorobj2 [glGenLists 1]
set objectarrow2 [glGenLists 1]
set WorldCoord2 [glGenLists 1]
set labframe [glGenLists 1]

set Shift -10




proc DrawCone { val } {
       global objectcone2 cone2 Shift 
       
.gl2 makeCurrent

   catch {glDeleteLists $objectcone2 1}
   
   glNewList $objectcone2 GL_COMPILE
   glColor4f 1.0 1.0 0 $val
   glPushMatrix
   glTranslatef 0 0 $Shift 
   glCallList $cone2
   glPopMatrix 
   glEndList
  
   .gl2 redraw

}


proc DrawArrow { degree } {
      global  objectarrow2 Shift arrow2 xarrowB1 yarrowB1 zarrowB1 
      global xarrowB0 yarrowB0 zarrowB0 flagA angVec2 labframe 

    set deg [expr 360 - $degree]

#GL2

.gl2 makeCurrent

    catch {glDeleteLists $objectarrow2 1}

    glNewList $objectarrow2 GL_COMPILE
    glColor3f 0.0 0.0 0.0 
    glPushMatrix 
    glTranslatef $xarrowB1 $yarrowB1 [expr $zarrowB1 + $Shift ] 
    glRotatef $deg  0.0 0.0 1.0
    glRotatef 90 1.0 0.0 0.0 
    glCallList $arrow2
    glPopMatrix 
    glEndList

    .gl2 redraw


set angVec $angVec2

if {$flagA == 1} {
set angVec2 $deg
set angVec 0
} else {
}

       




 .gl2 makeCurrent
  
   catch {glDeleteLists $labframe 1}

  glNewList $labframe GL_COMPILE
  glColor4f 0 0 0 1
  glPushMatrix
  glTranslatef 0 0 -10 
  glBegin GL_LINES
  glColor3f 1.0 0.0 0.0
  glVertex3d 0.0 0.0 0.0 
  glVertex3d 1.0 0.0 0.0 
  glColor3f 0.0 1.0 0.0 
  glVertex3d 0.0 0.0 0.0 
  glVertex3d 0.0 1.0 0.0 
  glColor3f 0.0 0.0 1.0 
  glVertex3d 0.0 0.0 0.0 
  glVertex3d 0.0 0.0 1.0 
  glEnd 
  glPopMatrix
  glEndList

.gl2 redraw
}


DrawCone 0.3



#seting up the rotational vector   
proc vectordraw { angle } {
  global vectorobj2 ang Shift xarrowB1 yarrowB1 zarrowB1 newRadius
 

set ang $angle
set v_radius 1
set h 1


for {set i 1} {$i<2} {incr i} {

set phase 90
set ang $angle

set coordx$i [expr {$newRadius * [expr cos(($phase + $ang)*3.141592654/180)]}]
set coordy$i [expr {$newRadius * [expr sin(($phase + $ang)*3.141592654/180)]}]
set coordz$i 0

}
set xarrowB1 $coordx1
set yarrowB1 $coordy1
set zarrowB1 $coordz1

  
.gl2 makeCurrent 
   
   catch {glDeleteLists $vectorobj2 1}
   
   glNewList $vectorobj2 GL_COMPILE
   glColor4f 0 0 0 1
   glPushMatrix 
   glTranslatef 0 0 $Shift 
   glDepthMask 1 
   glBegin GL_lines 
   glVertex3d 0 0 0 
   glVertex3d $coordx1 $coordy1 $coordz1 
   glEnd 
   glDepthMask 0 
   glPopMatrix 
   glEndList

   .gl2 redraw
}

##################
proc vectordraw2 { angle } {
  global ang2 Shift xarrowB1 yarrowB1 zarrowB1
  global xarrowB0 yarrowB0 zarrowB0 newRadius

set ang2 $angle
set v_radius 1
set h 1


for {set i 1} {$i<2} {incr i} {

set phase 90
set ang $angle

set coordx$i [expr {$newRadius * [expr cos(($phase + $ang)*3.141592654/180)]}]
set coordy$i [expr {$newRadius * [expr sin(($phase + $ang)*3.141592654/180)]}]
set coordz$i 0

}
  
set xarrowB0 $coordx1
set yarrowB0 $coordy1
set zarrowB0 $coordz1


         


}
####################

#create a switch for rotating the vector
frame .l -bg blue3 -width 200 -height 300
frame .l.rotate 
button .l.rotate.do -command {startRotate 360} -text "w = w0"
button .l.rotate.do2 -command {startRotate2 1000} -text "w < w0"
button .l.rotate.do3 -command {startRotate3 360} -text "w > w0"
button .l.rotate.stop -command stop -text "Stop"
frame .l.rotstatus
label .l.rotstatus.currl -text "current vector angle: " 
label .l.rotstatus.current -textvariable currentAng

pack .l.rotate.do .l.rotate.do2 .l.rotate.do3 .l.rotate.stop -side left -padx 3 -pady 3
pack .l.rotstatus.currl .l.rotstatus.current -side left -padx 3 -pady 3
pack .l.rotate -padx 3 -pady 3
pack .l.rotstatus -padx 3 -pady 3



set startAngle 0
set finishAngle 0
set currentAng 0

proc stop {} {
global ang startAngle finishAngle currentAng rotflag angVec2

set ang 0
set startAngle 0
set finishAngle 0
set currentAng 0
set rotflag 0
set angVec2 0
vectordraw 0
vectordraw2 0
DrawArrow 0
}

proc startRotate {deg} {
    global ang startAngle finishAngle currentAng 


set currentAng 0

# set the angle you want the animation to end at
    set finishAngle [expr $currentAng + $deg]

# call rotate switch (the argument should be used as a rotation increment)
    rotateVector 0
}
####################    
proc startRotate2 {deg} {
    global ang startAngle finishAngle currentAng 


set currentAng 0
 set finishAngle [expr $currentAng + $deg]
rotateVector2 0
  

}
 
proc startRotate3 {deg} {
    global ang startAngle finishAngle currentAng 

set currentAng 0
 set finishAngle [expr $currentAng + $deg]
rotateVector3 0
  

}
######################

# this will rotate the vector by amount degrees and 
# continue to do so until finishAngle degrees have been
# exceeded
# NOTE: you'll have to play with this so that things work correctly
#   if you want currentAng to reset to 0 after 360 degrees
#   (one way to do it is to specify the total number of degrees of rotation 
#   rather than a start and finish rotation setting)
proc rotateVector {amount} {
global startAngle finishAngle vectorobj currentAng flagA
set flagA 1
        vectordraw -$currentAng		
	  
set degree $currentAng
DrawArrow $degree

   
    if {$currentAng < $finishAngle} {
         incr currentAng $amount
		after 10 "rotateVector 1"
    } else {
       set startAngle $currentAng
    }
set flagA 0
}
######################
proc rotateVector2 {amount} {
global startAngle finishAngle vectorobj currentAng angVec2  

	  set angVec2 [expr -$currentAng * 4]  
	  vectordraw -$currentAng	
        vectordraw2 $angVec2
	  	
set degree $currentAng
DrawArrow $degree

    if {$currentAng < $finishAngle} {
         incr currentAng $amount
		after 10 "rotateVector2 1"

    } else {
       set startAngle $currentAng
    }

}
#####################
######################
proc rotateVector3 {amount} {
global startAngle finishAngle vectorobj currentAng angVec2  

	  set angVec2 [expr -$currentAng / 4]  
	  vectordraw -$currentAng	
        vectordraw2 $angVec2
	  	
set degree $currentAng
DrawArrow $degree

    if {$currentAng < $finishAngle} {
         incr currentAng $amount
		after 10 "rotateVector3 1"

    } else {
       set startAngle $currentAng
    }

}
#####################


frame .l.f 
label .l.f.l -text "Transparency"
scale .l.f.cone1 -from 0 -to 1 -resolution 0.01 -label "first cone" -command  DrawCone -orient horizontal
# creating a scale to change the position of the vector on the cone
scale .l.f.vectorAng -from 0 -to 360 -resolution 2 -label "vector angle" -command vectordraw -orient horizontal

pack .l.f -side bottom -padx 3 -pady 3 
pack .l.f.l -side top -padx 3 -pady 3 
pack .l.f.cone1 -side left -padx 3 -pady 3 
#pack .l.f.vectorAng -side bottom -padx 3 -pady 3 

.l.f.cone1 set 0.3

.l.f.vectorAng set 0

pack .l -side bottom


proc draw {} {

    global vectorobj2 objectarrow2 objectcone2 labframe WorldCoord2 Shift
    global val deg degree
	.gl2 makeCurrent

     glEnable GL_BLEND
     glEnable GL_DEPTH_TEST
     glEnable GL_LINE_SMOOTH 
     glClear GL_COLOR_BUFFER_BIT
     glClear GL_DEPTH_BUFFER_BIT
     glLineWidth 3
     glPushMatrix 
     glTranslatef 0 0 $Shift 
     glBegin GL_LINES
       glColor3f 1.0 0.0 0.0
       glVertex3d 0.0 0.0 0.0
       glVertex3d 1.0 0.0 0.0
       glColor3f 0.0 1.0 0.0
       glVertex3d 0.0 0.0 0.0
       glVertex3d 0.0 1.0 0.0
       glColor3f 0.0 0.0 1.0
       glVertex3d 0.0 0.0 0.0
       glVertex3d 0.0 0.0 1.0
     glEnd
     glPopMatrix
     glClearColor 1.0 1.0 1.0 0.1
     glCallList $vectorobj2
     glCallList $objectarrow2
     glCallList $labframe 
     glCallList $objectcone2 
     glCallList $WorldCoord2

	.gl2 swapBuffer

}

#rotational bindings and functions
# default manipulations

#GL2
bind .gl2 <Button-1> { set x %x ; set y %y }
bind .gl2 <B1-Motion> {
    incr xrot [expr %x - $x]
    incr yrot [expr %y - $y]
    set x %x
    set y %y

	Update $zrot
	Update $yrot
	Update $xrot 
	
}

set zrot 0
#GL2
bind .gl2 <Button-3> { set z %x }
bind .gl2 <B3-Motion> {

    incr zrot [expr %x - $z]
    set z %x

Update $zrot
Update $yrot
Update $xrot
}



scale .l.x -from -180 -to 180 -command "rotate x" -variable yrot -label X
scale .l.y -from -180 -to 180 -command "rotate y" -variable xrot -label Y
scale .l.z -from -180 -to 180 -command "rotate z" -variable zrot -label Z

proc rotate {ax val} {
   
    global zrot yrot xrot 

Update $zrot
Update $yrot
Update $xrot
}

pack .l.x .l.y .l.z -side left -padx 3 -pady 3


proc Update {var} {

global xrot yrot zrot Shift zoomAngle Xeye Yeye Zeye 
global Xcenter Ycenter Zcenter orthoZoom worldFlag 
global WorldCoord WorldCoord2 WorldCoord3 projFlag tempZrot tempYrot tempXrot 

if {$projFlag == 0} {



	.gl2 makeCurrent

       glEnable GL_BLEND
       glEnable GL_DEPTH_TEST
       glBlendFunc GL_SRC_ALPHA GL_ONE_MINUS_SRC_ALPHA
       glMatrixMode GL_PROJECTION
       glLoadIdentity
 glOrtho [expr -$orthoZoom] $orthoZoom  [expr -$orthoZoom] $orthoZoom  -20 20 
       glMatrixMode GL_MODELVIEW
       glLoadIdentity 
       gluLookAt $Xeye $Yeye $Zeye $Xcenter $Ycenter $Zcenter 0 1 0
       glTranslatef 0 0 $Shift
       glRotatef $zrot 0 0 1
       glRotatef $yrot 1 0 0
       glRotatef $xrot 0 1 0 
       glTranslatef 0 0 [expr -$Shift]

} else {
	.gl2 makeCurrent

       glEnable GL_BLEND
       glEnable GL_DEPTH_TEST
       glBlendFunc GL_SRC_ALPHA GL_ONE_MINUS_SRC_ALPHA
       glMatrixMode GL_PROJECTION
       glLoadIdentity
       gluPerspective $zoomAngle 1 0.1 50 
       glMatrixMode GL_MODELVIEW
       glLoadIdentity 
       gluLookAt $Xeye $Yeye $Zeye $Xcenter $Ycenter $Zcenter 0 1 0
       glTranslatef 0 0 $Shift
       glRotatef $zrot 0 0 1
       glRotatef $yrot 1 0 0
       glRotatef $xrot 0 1 0 
       glTranslatef 0 0 [expr -$Shift]



}


 if {$worldFlag == 1 } {

	.gl2 makeCurrent
  
   catch {glDeleteLists $WorldCoord2 1}
  glNewList $WorldCoord2 GL_COMPILE
  glColor4f 0 0 0 1
  glPushMatrix
  glTranslatef -1 -2 -12 
  glBegin GL_LINES
  glColor4f 1.0 0.0 0.0 1.0
  glVertex3d 0.0 0.0 0.0 
  glVertex3d 1.0 0.0 0.0 
  glColor4f 0.0 1.0 0.0 1.0 
  glVertex3d 0.0 0.0 0.0 
  glVertex3d 0.0 1.0 0.0 
  glColor4f 0.0 0.0 1.0 1.0 
  glVertex3d 0.0 0.0 0.0 
  glVertex3d 0.0 0.0 1.0 
  glEnd 
  glPopMatrix
  glEndList

set tempZrot 0
set tempXrot 0
set tempYrot 0
	
    } else {


	.gl2 makeCurrent
  
  catch {glDeleteLists $WorldCoord2 1}
  glNewList $WorldCoord2 GL_COMPILE
  glColor4f 0 0 0 1
  glPushMatrix
  glMatrixMode GL_MODELVIEW
  glLoadIdentity
  glTranslatef -1 -2 -12 
  glBegin GL_LINES
  glColor4f 1.0 0.0 0.0 1.0
  glVertex3d 0.0 0.0 0.0 
  glVertex3d 1.0 0.0 0.0 
  glColor4f 0.0 1.0 0.0 1.0 
  glVertex3d 0.0 0.0 0.0 
  glVertex3d 0.0 1.0 0.0 
  glColor4f 0.0 0.0 1.0 1.0 
  glVertex3d 0.0 0.0 0.0 
  glVertex3d 0.0 0.0 1.0 
  glEnd 
  glPopMatrix
  glEndList

   }
 
.gl2 redraw

}

# orient it so the all cones point down
set xrot -84
set yrot 19
set zrot -90
Update $yrot
Update $xrot
Update $zrot

draw

rotateVector2 0
rotateVector 0
