package require Tkogl
package require OpenGL
package require OpenGLU


OGLwin .gl -refresh draw -width 400 -height 400
pack .gl -side left -expand yes -fill both

set fogmode GL_EXP
set fogdensity 0.35
set fogstart 0
set fogend 5

frame .controls
pack .controls -side right -fill y

button .quit -text "Quit" -command exit
pack .quit -in .controls -fill x

foreach mode { GL_EXP GL_EXP2 GL_LINEAR } {
    radiobutton .m$mode -text $mode -var fogmode -value $mode -command {
        .gl makeCurrent 
        glFogi GL_FOG_MODE $fogmode
        .gl redraw
	packscales
    }
    pack .m$mode -in .controls -side top -anchor w
}

scale .density -label density -from 0 -to 1 -res 0.05 -orient vert \
	-var fogdensity -command changedensity

proc changedensity { fogdensity } {
    .gl makeCurrent
    glFogf GL_FOG_DENSITY $fogdensity
    .gl redraw
}

scale .start -label start -from 0 -to 10 -res 0.1 -orient vert \
	-var fogstart -command "changerange GL_FOG_START"
scale .end -label end -from 0 -to 10 -res 0.1 -orient vert \
	-var fogend -command "changerange GL_FOG_END"

proc changerange { parm value } {
    .gl makeCurrent
    glFogf $parm $value
    .gl redraw
}

proc packscales {} {
    global fogmode 
    if {$fogmode=="GL_LINEAR"} {
	catch "pack forget .density"
	pack .start -in .controls -anchor w
	pack .end -in .controls -anchor w
    } else {
	catch "pack forget .start"
	catch "pack forget .end"
	pack .density -in .controls -anchor w
    }
}

packscales

  set speclight [newfv4 1 1 1 1]
  .gl makeCurrent
  glMatrixMode GL_PROJECTION
  glLoadIdentity 
  glOrtho -4 4 -4 4 -8 8 
  glMatrixMode GL_MODELVIEW
  glLoadIdentity 
  glColorMaterial GL_FRONT_AND_BACK GL_AMBIENT_AND_DIFFUSE  
  glMaterialfv GL_FRONT GL_SPECULAR $speclight 
  glMateriali GL_FRONT GL_SHININESS 50 
  glFogf GL_FOG $fogmode
  glFogf GL_FOG_DENSITY $fogdensity
  glFogf GL_FOG_START $fogstart
  glFogf GL_FOG_END $fogend
  glLightf GL_LIGHT0 GL_POSITION [newfv4 10 10 10 0]
  glEnable GL_COLOR_MATERIAL
  glEnable GL_LIGHTING
  glEnable GL_LIGHT0
  glEnable GL_DEPTH_TEST
  glEnable GL_FOG

set qobj [gluNewQuadric]

proc draw {} {
  global qobj

  glMatrixMode GL_MODELVIEW
  glLoadIdentity

  glClear GL_COLOR_BUFFER_BIT
  glClear GL_DEPTH_BUFFER_BIT

  glColor3f 1 0 0
  glPushMatrix
  glTranslatef -2 0 0 
  gluSphere $qobj 1 20 20
  glPopMatrix

  glColor3f 1 1 0
  glPushMatrix
  glTranslatef 0 0 2 
  gluSphere $qobj 1 20 20
  glPopMatrix  

  glColor3f 0 1 0
  glPushMatrix
  glTranslatef 2 0 4 
  gluSphere $qobj 1 20 20
  glPopMatrix  

  .gl swapBuffer
}


