#---------------------------------------------------------------------------
#
#  PROCS FOR HANDLING SETS AND PROPERTY LISTS
#
#---------------------------------------------------------------------------

proc includeset { setname element } {
    upvar $setname set
    if [lsearch $set $element]==-1 { lappend set $element }
}

proc inset { setname element } {
    upvar $setname set
    return [expr [lsearch $set $element]!=-1]
}

proc getprop {proplist fieldname} {
    return [lindex $proplist [lsearch $proplist "$fieldname*"]]
}

proc getpropval {proplist fieldname} {
    return [lreplace [getprop $proplist $fieldname] 0 0]
}

proc printproplist {l {indent 0}} {
    set name [lindex $l 0]
    set rest [lreplace $l 0 0]    
    puts -nonewline [format "%${indent}s" ""]
    if [llength $rest]==1 { 
	puts "$name $rest"
    } else {
	puts $name
	foreach item $rest {
	    printproplist $item [expr $indent+2]
	}
    }
}

