package require Tkogl
package require OpenGL
package require OpenGLU

set message "Message"
set typeFace "Helvetica"
set height 0
set weight 0
set italic 0
set underline 0
set strikethrough 0
set xpos 0
set ypos 0

OGLwin .gl -width 400 -height 400
pack .gl -side bottom

glClear GL_COLOR_BUFFER_BIT

set font [.gl createFont $typeFace $height $weight $italic $underline $strikethrough]

proc putText {} {
	global font message typeFace height weight italic underline strikethrough xpos ypos
	
	.gl deleteFont $font
	set font [.gl createFont $typeFace $height $weight $italic $underline $strikethrough]
	.gl makeCurrent
	glRasterPos2f $xpos $ypos
	.gl putString $font $message
	.gl redraw
}

frame .controls

frame .bar1
frame .bar2
frame .bar3
frame .buttons

label .typeFaceLabel -text "Type Face :"
label .messageLabel -text "Message :"
label .heightLabel -text "Height :"
label .weightLabel -text "Weight :"
label .xposLabel -text "X :"
label .yposLabel -text "Y :"

entry .typeFaceEntry -relief sunken -textvariable typeFace
entry .messageEntry -relief sunken -textvariable message
entry .heightEntry -width 5 -relief sunken -textvariable height
entry .weightEntry -width 5 -relief sunken -textvariable weight
entry .xposEntry -width 5 -relief sunken -textvariable xpos
entry .yposEntry -width 5 -relief sunken -textvariable ypos
checkbutton .italicButton -text "Italic" -variable italic -anchor w
checkbutton .underlineButton -text "Underline" -variable underline -anchor w
checkbutton .strikethroughButton -text "Strikethrough" -variable strikethrough -anchor w

button .go -command putText -text "Go" 
button .exit -command exit -text "Exit"

pack .messageLabel .messageEntry .xposLabel .xposEntry -in .bar1 -side left -fill x
pack .go .exit -in .bar1 -side right
pack .typeFaceLabel .typeFaceEntry .yposLabel .yposEntry -in .bar2 -side left -fill x
pack .heightLabel .heightEntry .weightLabel .weightEntry .italicButton .underlineButton .strikethroughButton -in .bar3 -side left

pack .bar1 -in .controls -side top -fill x
pack .bar2 -in .controls -fill x
pack .bar3 -in .controls -side bottom -fill x
pack .controls -side top -fill x


