package require Tkogl
package require OpenGL
package require OpenGLU


proc createcheckerimg {} {
    image create photo tmp -width 2 -height 2
    image create photo img -width 64 -height 64
    tmp put {{#ffffff #ff0000} {#000000 #ffffff}} 
    img copy tmp -from 0 0 2 2 -zoom 4 4 -to 0 0 64 64
    rename tmp {}
}

proc redisplay {} {
	global yrot dlist

	glMatrixMode GL_PROJECTION
	glLoadIdentity
	gluPerspective 30 1 0.1 10
	glMatrixMode GL_MODELVIEW
	glLoadIdentity
	gluLookAt -3 2 3  0 0 0  0 1 0
	glClear GL_DEPTH_BUFFER_BIT
	glClear GL_COLOR_BUFFER_BIT
	glRotatef $yrot 1 1 0

	glCallList $dlist

	.gl swapBuffer
}

proc doStuff {} {
	global yrot
	redisplay

	incr yrot 5
	after 10 doStuff
}

pack [OGLwin .gl -width 300 -height 300 -refresh redisplay] -side left -expand yes -fill both
pack [frame .cmdframe] -side right -fill y

button .quit -text "Quit" -command exit
pack .quit -in .cmdframe -fill x

radiobutton .cyltex -text "Cylindrical Coordinates" -var texmode -value cyltex\
	-command {
	glDisable GL_TEXTURE_GEN_S
	glDisable GL_TEXTURE_GEN_T
}

radiobutton .objlinear -text "Object Linear" -var texmode -value objlinear\
	-command {
#	    .gl eval -texgen s texturegenmode objectlinear \
#	    -texgen t texturegenmode objectlinear \
#	    -enable texturegens \
#	    -enable texturegent
    	glTexGeni GL_TEXTURE_GEN_S GL_TEXTURE_GEN_MODE GL_OBJECT_LINEAR
	glTexGeni GL_TEXTURE_GEN_T GL_TEXTURE_GEN_MODE GL_OBJECT_LINEAR
	glEnable GL_TEXTURE_GEN_S
	glEnable GL_TEXTURE_GEN_T
	glFlush
}

radiobutton .eyelinear -text "Eye Linear" -var texmode -value eyelinear\
	-command {
#	    .gl eval -texgen s texturegenmode eyelinear \
#	    -texgen t texturegenmode eyelinear \
#	    -enable texturegens \
#	    -enable texturegent
	glTexGeni GL_TEXTURE_GEN_S GL_TEXTURE_GEN_MODE GL_EYE_LINEAR
	glTexGeni GL_TEXTURE_GEN_T GL_TEXTURE_GEN_MODE GL_EYE_LINEAR
	glEnable GL_TEXTURE_GEN_S
	glEnable GL_TEXTURE_GEN_T
	glFlush
}

radiobutton .checker -text "Checkerboard texture" -var teximg -value checker\
	-command {
	catch {rename img {} }
	createcheckerimg
	.gl texImage2D 0 0 img
}

radiobutton .teapot -text "Teapot Photo texture" -var teximg -value teapot\
	-command {
	global tk_library
	catch {rename img {} }
	image create photo img -file ${tk_library}/demos/images/teapot.ppm
	.gl texImage2D 0 0 img
}


pack .cyltex .objlinear .eyelinear .checker .teapot -in .cmdframe \
	-anchor w

.checker invoke 
.cyltex invoke

.gl texImage2D 0 0 img

glEnable GL_DEPTH_TEST
glTexParameteri GL_TEXTURE_2D GL_TEXTURE_WRAP_S GL_REPEAT
glTexParameteri GL_TEXTURE_2D GL_TEXTURE_WRAP_T GL_REPEAT
glTexParameteri GL_TEXTURE_2D GL_TEXTURE_MAG_FILTER GL_NEAREST
glTexParameteri GL_TEXTURE_2D GL_TEXTURE_MIN_FILTER GL_NEAREST
glTexEnvi GL_TEXTURE_ENV GL_TEXTURE_ENV_MODE GL_MODULATE

glTexGenfv GL_TEXTURE_GEN_S GL_OBJECT_PLANE [newfv4 1 0 0 0]
glTexGenfv GL_TEXTURE_GEN_T GL_OBJECT_PLANE [newfv4 0 0 1 0]

glShadeModel GL_SMOOTH
glEnable GL_TEXTURE_2D

glLightfv GL_LIGHT0 GL_AMBIENT [newfv4 1 1 1 1]
glLightfv GL_LIGHT0 GL_DIFFUSE [newfv4 1 1 1 1]
glLightfv GL_LIGHT0 GL_POSITION [newfv4 1 1 1 0]
glLightfv GL_LIGHT0 GL_SPECULAR [newfv4 1 1 1 1]

glEnable GL_LIGHTING 
glEnable GL_LIGHT0 

glMaterialfv GL_FRONT GL_AMBIENT [newfv4 0.4 0.4 0.4 0]
glMaterialfv GL_FRONT GL_DIFFUSE [newfv4 0.5 0.5 0.5 0]
glMaterialfv GL_FRONT GL_SPECULAR [newfv4 0.5 0.5 0.5 0]
glMateriali GL_FRONT GL_SHININESS 50

glEnable GL_DEPTH_TEST
glEnable GL_LIGHTING

# .gl eval -texgen t objectplane  0 0 1 0

set info [.gl gencyl -texgen 0 1 0 1 -polygon 0.5 20 -plot -transl 0 0 1 -plot]
set dlist [lindex [lindex $info 0] 1]
set yrot 0

doStuff
