# A Makefile for MSVC++ 4.x/5.x
#
# Location of the Visual C++ tools
#TOOLS         = $(MSVCDIR)
TOOLS          = F:\vc98
TCL            = D:\work\ActiveTcl

# The C/C++ compiler
CC            = cl.exe

# The linker
LINK          = link.exe

# Include directories for your compiler
INCLUDE32     = -I"$(TOOLS)\include"

# Target machine
MACHINE       = IX86

# C Libraries needed to build a DLL
DLLIBC        = msvcrt.lib oldnames.lib  

# Other windows libraries that are apparently needed
#WINLIB        = kernel32.lib advapi32.lib user32.lib gdi32.lib comdlg32.lib winspool.lib
WINLIB        = kernel32.lib advapi32.lib user32.lib gdi32.lib 
GLLIB         = opengl32.lib glu32.lib

# Libraries common to all DLLs
DLLLIBS       = $(DLLIBC) $(WINLIB) $(GLLIB)

# Linker options
LOPT      = -debug:full -debugtype:cv /NODEFAULTLIB /RELEASE /NOLOGO /MACHINE:$(MACHINE) -entry:_DllMainCRTStartup@12 -dll

# C compiler flags
CFLAGS    =  /Z7 /Od /c  /nologo /DEBUG /D_DLL $(INCLUDE32)\GL /D__WIN32__

# SWIG Installation
SWIG        = D:\work\SWIG1.1p5\swig
SWIGOPT		= -ID:\work\SWIG1.1p5\swig_lib


# OpenGL files
SRCS         =
INTERFACE    = openglu.i
WRAPFILE     = openglu_wrap.c
TARGET       = openglu.dll

# Now munge the files provided
# SRCS     = list of source files
# WRAPFILE = Outfile file for SWIG

SRCS         = $(SRCS) $(WRAPFILE)
OBJS         = $(SRCS:.cxx=.obj) 
OBJS         = $(OBJS:.c=.obj)
OBJS         = $(OBJS:/Tp=)

# ------------------------------------------------------------------
# Tcl settings
# 
# TCL_INCLUDES  = Include files for your Tcl installation.
#                 Typically you want Tcl/generic and Tcl/win.
# TCLLIB        = The location of the tcl library
# ------------------------------------------------------------------

TCL_INCLUDES  = -I$(TCL)\include
TCLLIB        = $(TCL)\lib\tcl84.lib

tcl::
	$(SWIG) -tcl -o $(WRAPFILE) $(SWIGOPT) $(INTERFACE)
	$(CC) $(CFLAGS) $(TCL_INCLUDES) $(SRCS) 
	set LIB=$(TOOLS)\lib
	$(LINK) $(LOPT) -out:Tcl\$(TARGET) $(DLLLIBS) $(TCLLIB) $(OBJS) 

clean::
	del *.obj
	del *.dll
	del *.exp
	del *.lib
	del *.pdb
	del *_wrap*
















