PROJECT	= Tkogl

#
# Project directories -- these may need to be customized for your site
#
# ROOT --	location of the source files
# TMPDIR -- location for .obj files.
# TOOLS32 -- location of VC++ compiler installation.
# TCL --	location where Tcl is installed.
# TCLSOURCE -- root dir of source Tcl distrib.
# TKSOURCE -- root dir of source Tk distrib.
#

ROOT	   = .
TMPDIR	   = .
TOOLS32    = F:\VC98
TCL	       = D:\work\ActiveTcl
TCLDLL     = D:\work\ActiveTcl\bin
OPENGLLIB  = D:\work\tkogl\swig.gl\tcl
OPENGLULIB = D:\work\tkogl\swig.glu\tcl
TCLINCLUDE = $(TCL)\include
TCLSOURCE  = D:\work\tcl8.4.1
TKSOURCE   = D:\work\tk8.4.1

# comment the following line to compile with symbols
NODEBUG=1

# Tcl version to compile against.

VER	= 84

# Set this to the appropriate value of /MACHINE: for your platform
MACHINE	= IX86

##################
# Project settings
##################

DLLOBJS = \
	tkogl.obj \
	get.obj \
	glphoto.obj \
	load3ds.obj \
	gencyl.obj \
	printstr.obj \
	nurbs.obj \
	tess.obj \
	quadric.obj
		

cc32		= $(TOOLS32)\bin\cl.exe
link32		= $(TOOLS32)\bin\link.exe

CP		= copy
RM		= del
MKDIR   = mkdir

TKINCLUDES = $(TKSOURCE);$(TCLINCLUDE);$(TCLINCLUDE)\X11;
TCLINCLUDES = $(TCLINCLUDE);$(TCLINCLUDE)\X11;$(TCLSOURCE);

include		= -I$(TOOLS32)\include -I$(TCLSOURCE)\win -I$(TKSOURCE)\win \
		  -I$(TCLINCLUDE)\X11 -I$(TCLINCLUDE) -I$(TKSOURCE)\generic \
		  -I$(TCLSOURCE)\generic
DLL_CFLAGS	= $(cdebug) $(cflags) $(include)
DLL_LIBS	= $(TCL)\lib\tcl$(VER).lib $(TCL)\lib\tk$(VER).lib $(TOOLS32)\lib\opengl32.lib \
			  $(OPENGLLIB)\opengl.lib $(OPENGLULIB)\openglu.lib $(TOOLS32)\lib\glu32.lib \
			  $(conlibsdll)

#DLL_LIBS	= $(TCL)\lib\tcl84.lib $(TCL)\lib\tk84.lib opengl32.lib opengl.lib\

######################################################################
# Link flags
######################################################################

!IFDEF NODEBUG
ldebug = /RELEASE
!ELSE
ldebug = -debug:full -debugtype:cv
!ENDIF

# declarations common to all linker options
lcommon = /NODEFAULTLIB /RELEASE /NOLOGO

# declarations for use on Intel i386, i486, and Pentium systems
!IF "$(MACHINE)" == "IX86"
DLLENTRY = @12
lflags   = $(lcommon) -align:0x1000 /MACHINE:$(MACHINE)
!ELSE
lflags   = $(lcommon) /MACHINE:$(MACHINE)
!ENDIF

dlllflags = $(lflags) -entry:_DllMainCRTStartup$(DLLENTRY) -dll

!IF "$(MACHINE)" == "PPC"
libcdll = crtdll.lib
!ELSE
libcdll = msvcrt.lib
!ENDIF

conlibsdll = $(libcdll) kernel32.lib user32.lib gdi32.lib comdlg32.lib

######################################################################
# Compile flags
######################################################################

!IFDEF NODEBUG
cdebug = -Ox
!ELSE
cdebug = /Z7 /Od 
!ENDIF

# declarations common to all compiler options
ccommon = -c -W3 -nologo -DWIN32 -D_WIN32_ -D_WIN32 -D_DLL

!IF "$(MACHINE)" == "IX86"
cflags = $(ccommon) -D_X86_=1
!ELSE
!IF "$(MACHINE)" == "MIPS"
cflags = $(ccommon) -D_MIPS_=1
!ELSE
!IF "$(MACHINE)" == "PPC"
cflags = $(ccommon) -D_PPC_=1
!ELSE
!IF "$(MACHINE)" == "ALPHA"
cflags = $(ccommon) -D_ALPHA_=1
!ENDIF
!ENDIF
!ENDIF
!ENDIF

######################################################################
# Project specific targets
######################################################################

all: pkgIndex.tcl

test: pkgIndex.tcl
	@$(TCL)\bin\tclsh$(VER) <<
		lappend auto_path $(ROOT)
		#package require $(PROJECT)
		load "c:\\interactive3d\\tkoglv2.2\\src\\tkogl.dll"
		load "c:\\interactive3d\\tkoglv2.2\\src\\opengl.dll"
		load "c:\\interactive3d\\tkoglv2.2\\src\\openglu.dll"
		if ![catch {$(PROJECT)}] {
		    puts "Test passed."
		    exit 0
		} else {
		    puts "$(PROJECT) failed to load and run"
		    exit 1
		}
<<

install: pkgIndex.tcl
	@if not exist $(TCL)\lib\example $(MKDIR) $(TCL)\lib\example
	@$(CP) $(PROJECT).dll $(TCL)\lib\example
	@$(CP) pkgIndex.tcl $(TCL)\lib\example

pkgIndex.tcl: $(PROJECT).dll
#	$(TCL)\bin\tclsh$(VER) <<
#		pkg_mkIndex -direct $(ROOT) $(PROJECT).dll
#<<

$(PROJECT).dll: $(DLLOBJS)
	$(link32) $(ldebug) $(dlllflags) -out:Tcl\$@ $(DLL_LIBS) @<<
		$(DLLOBJS)
<<

#######################################################################
# Implicit Targets
#######################################################################


# Implicit Targets

.c.obj:
	$(cc32) $(DLL_CFLAGS) $<

clean:
	-$(RM) $(TMPDIR)\*.obj
	-$(RM) *.dll
	-$(RM) pkgIndex.tcl
	-$(RM) *.lib
	-$(RM) *.exp




